package com.acj0.orangediaryproa.mod.import1;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.acj0.share.R;
import com.acj0.share.mod.googleapi.GDocsSpreadsheetEntry;

public class BaseAdapterGDocsSpreadsheet extends BaseAdapter {
	
	private List<GDocsSpreadsheetEntry> mList;
	private LayoutInflater mInflater;
	
	// Constructor
	public BaseAdapterGDocsSpreadsheet(Context context, List<GDocsSpreadsheetEntry> list) {
		mInflater = LayoutInflater.from(context);
		mList = list;
	}

	public int getCount() {
		return mList.size();
	}

	public Object getItem(int position) {
		return position;
	}

	public long getItemId(int position) {
		return position;
	}
	
	static class ViewHolder {
		ImageView iv_bullet;
		TextView tv_label;
        TextView tv_notecount;
    }

	public View getView(int position, View convertView, ViewGroup parent) {
		
		ViewHolder holder;

        if (convertView == null) {
    		convertView = mInflater.inflate(R.layout.mod_import_main_detail, parent, false);
        	
            holder = new ViewHolder();
            holder.iv_bullet = (ImageView) convertView.findViewById(R.id.iv_bullet);
            holder.tv_label = (TextView) convertView.findViewById(R.id.tv_label);
            holder.tv_notecount = (TextView) convertView.findViewById(R.id.tv_notecount);

            holder.tv_notecount.setVisibility(View.GONE);
            
            convertView.setTag(holder);
        } 
        else {
            holder = (ViewHolder) convertView.getTag();
        }
        
        
        GDocsSpreadsheetEntry sd = mList.get(position);
		
		holder.tv_label.setText(sd.title);
//		holder.tv_notecount.setText(sd.term_count+"");
		
		return convertView;
	}
}
