package com.acj0.orangediaryproa.util;

import android.app.Activity;

import com.acj0.orangediaryproa.R;
import com.acj0.orangediaryproa.data.MyApp;
import com.acj0.share.mod.demo.DemoUtils;

public class MyDemoUtils extends DemoUtils {

	public MyDemoUtils(Activity context) {
		
		if (MyApp.APP_MODE != MyApp.APP_MODE_DEMO) return;
		
		mAppMode = MyApp.APP_MODE;
		mAppName = MyApp.APP_NAME_LONG;
		mPkgName = MyApp.PACKAGE_PROA;
		mIconRes = MyApp.ICON_PKG;
		
		String demoText1 = "";
		String demoText2 = "";
		if (MyApp.SYSTEM_LANG.equals("en")) {
			demoText1 = "This is demo version with max 16 entry limitation.  If you like it, please support us by purchasing Pro version. ";
			demoText2 = 
				"This is demo version with max 16 entry limitation. " +
				"If you like it, please support us by purchasing Pro version.<br><br>" +
				"Thanks for your support.<br><br>" +
				" If you want to transfer your data from Demo to Pro version, please check<br>" +
				"<a href='"+MyApp.WEBSITE_HELP+"/how-to-transfer-data-from-demo-to-pro'>this documentation</a>";
		}
		else {
			demoText1 = context.getString(R.string.common1_demo_desc1);
			demoText2 = context.getString(R.string.common1_demo_desc2);
		}
		
		setVariable(context, demoText1, demoText2);
	}
	
}
