package com.acj0.orangediaryproa;

import java.io.File;
import java.net.URI;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.provider.MediaStore;
import android.support.v4.app.FragmentActivity;
import android.support.v4.view.GestureDetectorCompat;
import android.text.Html;
import android.text.format.DateFormat;
import android.text.util.Linkify;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Display;
import android.view.GestureDetector;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.ScaleGestureDetector;
import android.view.ScaleGestureDetector.SimpleOnScaleGestureListener;
import android.view.SubMenu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnCreateContextMenuListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.EditText;
import android.widget.Gallery;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import com.acj0.orangediaryproa.adapter.BaseAdapterIconList;
import com.acj0.orangediaryproa.adapter.CursorAdapterItem1;
import com.acj0.orangediaryproa.data.DBAdapter;
import com.acj0.orangediaryproa.data.EntryData;
import com.acj0.orangediaryproa.data.EntryOper;
import com.acj0.orangediaryproa.data.Icon;
import com.acj0.orangediaryproa.data.Intent1;
import com.acj0.orangediaryproa.data.ItemData;
import com.acj0.orangediaryproa.data.ItemOper;
import com.acj0.orangediaryproa.data.LabelData1;
import com.acj0.orangediaryproa.data.LabelData2;
import com.acj0.orangediaryproa.data.LabelOper;
import com.acj0.orangediaryproa.data.LabelOper2;
import com.acj0.orangediaryproa.data.Multimedia;
import com.acj0.orangediaryproa.data.MyApp;
import com.acj0.orangediaryproa.mod.alarm.Reminder;
import com.acj0.orangediaryproa.mod.expn.Expense;
import com.acj0.orangediaryproa.mod.expn.ListExpnItem;
import com.acj0.orangediaryproa.mod.task.ListTaskItem;
import com.acj0.orangediaryproa.mod.task.Task1;
import com.acj0.orangediaryproa.util.Log1;
import com.acj0.orangediaryproa.util.MyDemoUtils;
import com.acj0.share.ShareIntent;
import com.acj0.share.SharePref;
import com.acj0.share.mod.dialog.dtpkr2.DatePickerDialog02;
import com.acj0.share.mod.dialog.dtpkr2.TimePickerDialog03;
import com.acj0.share.mod.file.ListFilePickr;
import com.acj0.share.mod.icon.IconAlertDialog;
import com.acj0.share.mod.icon.IconAlertDialog.OnIconDialogListener;
import com.acj0.share.mod.launcher.ActivityLauncher;
import com.acj0.share.mod.recorder.SoundRecorder;
import com.acj0.share.mod.theme.Theme100;
import com.acj0.share.utils.DateUtils1;
import com.acj0.share.utils.IOUtils;
import com.acj0.share.utils.Util;

public class ViewEntryBackup extends FragmentActivity {
	
	private static final String TAG = "ViewNote1";
	
	public static final String[] SCREEN_ELEMS_PREF = {
		MyPref.KEY_SHOWHIDE_VIEWER_ELEM0,
		MyPref.KEY_SHOWHIDE_VIEWER_ELEM1
	};
	public static final int SCREEN_ELEM_COUNT = SCREEN_ELEMS_PREF.length;
	
	// Menu
	private static final int MENU_ITEM_DEL_NOTE = 		1;
	private static final int MENU_ITEM_EDIT = 			2;
	private static final int MENU_ITEM_TAG = 			3;
	private static final int MENU_ITEM_SHARE = 			4;
	private static final int MENU_ITEM_DISP_OPTION = 	5;
	
	private static final int MENU_ITEM_SUB0 = 		30;
	private static final int MENU_ITEM_ATTACH = 		31;
	private static final int MENU_ITEM_REMINDER = 	32;
	
	private static final int CMENU_ITEM_VIEW = 		40;
	private static final int CMENU_ITEM_VIEW_INFO = 	41;
	private static final int CMENU_ITEM_DEL = 		42;
	private static final int CMENU_ITEM_SEND = 		43;
	private static final int CMENU_ITEM_REGEN = 		44;
	
	// MV
	private int 		mExtraItemType;
	private long 		mExtraCreated;
	private String 	mExtraLabel;
	private long 		mExtraFolder;
	private int 		mExtraMarker;

	private long[] 	mExtraNoteIdArray;
	private int 		mExtraNotePosition;
	
	private long 		mExtraEntryId;
	private int 		mSelectedItemPosition;
	
	private DBAdapter mDbHelper;
	private Display mDisplay;
	private EntryOper mEntry1;
	private ItemOper mItem1;
	private ItemData mID;
	private Reminder mReminder;
	private LabelOper mLabel1;
	private LabelOper2 mLabel2;
	private LabelData1	mTagData;
	private LabelData2	mFldData;
	private Icon mIcon;

	private boolean 	mforceCloseThread;
	
	private EntryData mED;
	private Cursor 	mItemCursor;
	private String 	mPhotoFileFull;
	private long 		mPhotoTime;
	private String 	mVoiceFileFull;
	private long 		mVoiceTime;
	private String 	mGeneralFileFull;
	
	private boolean 	menuTriggered;
	private List<String> mMissingThumbList;
	
	private boolean 	mIsInArray;
	
	private GestureDetectorCompat mGestureDetector;
	private ScaleGestureDetector mScaleGestureDetector;
	
	// Mod Todo
	private Cursor 	mCursorTask;
	private Cursor 	mCursorExpn;
	
	// Dialog
	DatePickerDialog02 mDatePickerDialog;		// for date type
	TimePickerDialog03 mTimePickerDialog;		// for time type
	
	private static final int DIA_DEL_NOTE = 			0;
//	private static final int DIA_DATE = 				19;
//	private static final int DIA_TIME = 				20;
	private static final int DIA_MARKER = 			3;
	private static final int DIA_SHARE_SNG = 			5;
	private static final int DIA_DISP_OPTION = 		6;
	
//	private static final int DIA_LABEL_NEW = 		40;
	private static final int DIA_TAG_INS = 			41;
	private static final int DIA_TAG_LST = 			42;
	private static final int DIA_FLD_INS = 			43;
	private static final int DIA_FLD_LST = 			44;
	
	private static final int DIA_INS_ITEM = 			11;
	private static final int DIA_DEL_ITEM_LINK = 	12;
	private static final int DIA_DEL_ITEM_ALL = 		15;
	private static final int DIA_VIEW_ITEM = 		13;
	private static final int DIA_ITEM_INCONSISTENCY = 14;

	private static final int DIA_TASK_PICKR = 		31;
	private static final int DIA_EXPN_PICKR = 		33;
	private static final int DIA_TASKEXPN_NEW = 		35;
	
	
	public void removeDialogs() {
		removeDialog(DIA_DEL_NOTE);
//		removeDialog(DIA_DATE);
//		removeDialog(DIA_TIME);
		removeDialog(DIA_TAG_LST);
		removeDialog(DIA_MARKER);
		removeDialog(DIA_SHARE_SNG);
		removeDialog(DIA_DISP_OPTION);
		
		removeDialog(DIA_INS_ITEM);
		removeDialog(DIA_DEL_ITEM_LINK);
		removeDialog(DIA_VIEW_ITEM);
		removeDialog(DIA_ITEM_INCONSISTENCY);

		removeDialog(DIA_TASK_PICKR);
		removeDialog(DIA_EXPN_PICKR);
		removeDialog(DIA_TASKEXPN_NEW);
		
    	if (mDatePickerDialog!=null) 	mDatePickerDialog.dismiss();
    	if (mTimePickerDialog!=null) 	mTimePickerDialog.dismiss();

	}
	
	// Pref
	private SharedPreferences mSharedPref;
	private SharedPreferences.Editor mSharedPrefEdit;
	private boolean[] mScreenElems = {true,true};		// 0: attach, 1: edit
	private int mPrefTextColor;
	private int mPrefTextSizeT;
	private int mPrefTextSizeB;
	private int mPrefTextType;
	private int mPrefTaskSortOrder;
	private int mPrefExpnSortOrder;
	private int mPrefMarkerDefault;
	private String mPrefMarkerLinked;
	private int mPrefThumbChoice;
	private boolean mPrefHyperlinkEnabled;
	private String mPrefPhotoFilePath;
	
	// handler
	private static final int HANDLER_LOAD_THUMB = 1;
//	private static final int HANDLER_COPY_ATTACH = 2;
	
	private ProgressDialog mProgressDialog;
	private static int mErrorCode = 0;
	private static String mErrorMsg = "";
	
	private final Handler handler = new Handler() {
		@Override
		public void handleMessage(final Message msg) {
			switch (msg.what) {
			case HANDLER_LOAD_THUMB:
				if (!mforceCloseThread) {
					refreshGa01();
		    	}
				break;
			}
		}
	};
	
	public class MySimpleOnScaleGestureListener extends SimpleOnScaleGestureListener {

		@Override
		public boolean onScale(ScaleGestureDetector detector) {
			float mScaleFactor = 1.f;
			
//			mScaleFactor *= detector.getScaleFactor();
//			mScaleFactor = Math.max(mPrefTextSizeB, Math.min(mScaleFactor, 50.0f));
			
			float scale = detector.getScaleFactor();
			float textSize = mPrefTextSizeB*scale;
			  
			tv_body01.setTextSize(textSize);
			
			Log.e(TAG, "SimpleOnScaleGestureListener: "+textSize+", "+scale);
			return true;
		}

		@Override
		public boolean onScaleBegin(ScaleGestureDetector detector) {
			// TODO Auto-generated method stub
			return super.onScaleBegin(detector);
		}

		@Override
		public void onScaleEnd(ScaleGestureDetector detector) {
			// TODO Auto-generated method stub
			super.onScaleEnd(detector);
		}
		
		
	}
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        if (MyApp.DEBUG) Log.e(TAG,"onCreate-start");
        
        // Three cases coming
        // New Entry : action N , Id: N
        // Sent entry: action Y , Id: N
        // Edit entry: action N , Id: Y
        
        // Extra
        Intent intent = getIntent();
        String action = intent.getAction();
        if (action!= null && action.equals(Intent.ACTION_SEND)) {
        	initFromIntent(intent);
        }
        else {
	        Bundle extras = getIntent().getExtras();
	        if (extras != null) {
	        	mExtraNoteIdArray = extras.getLongArray(Intent1.EXTRA_ENTRY_ID_ARRAY);
	        	mExtraNotePosition = extras.getInt(Intent1.EXTRA_ENTRY_POSITION);
	        	mExtraEntryId = extras.getLong(Intent1.EXTRA_ENTRY_ID);
	        	
	        	mExtraItemType = extras.getInt(Intent1.EXTRA_ITEM_TYPE);
	        	mExtraCreated = extras.getLong(Intent1.EXTRA_NOTE_CREATED);
	        	mExtraMarker = extras.getInt(Intent1.EXTRA_NOTE_MARKERID);
	        	mExtraLabel = extras.getString(Intent1.EXTRA_LABEL_ID);
	        	mExtraFolder = extras.getLong(Intent1.EXTRA_FOLDER_ID);
	        }
        }

        if(		mExtraNoteIdArray!=null && mExtraNoteIdArray.length>1 &&
        		mExtraNotePosition>=0 && mExtraNotePosition<=mExtraNoteIdArray.length-1)
        	mIsInArray = true;
        else 
        	mIsInArray = false;
        
        // At this point, ACTION_SEND entry is the same as edit entry. 
        
        if (MyApp.DEBUG) Log.e(TAG, 
        		"Extras: Id"+mExtraEntryId+
        		", Type: "+mExtraItemType+
        		", Created: "+mExtraCreated+
        		", Tag: "+mExtraLabel+
        		", Folder: "+mExtraFolder+
        		", Marker: "+mExtraMarker
        		);
        
        // MV
		mDisplay = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay(); 
        mDbHelper = new DBAdapter(this);
        mEntry1 = new EntryOper(this,mDbHelper);
        mItem1 = new ItemOper(this,mDbHelper);
        mReminder = new Reminder(this);
        mIcon = new Icon(this);
        
        mSharedPref = PreferenceManager.getDefaultSharedPreferences(this);
        mSharedPrefEdit = mSharedPref.edit();
        
     // Set theme & screen
		mPrefTextColor = mSharedPref.getInt(MyPref.KEY_TEXTCOLOR, MyPref.VAL_TEXTCOLOR);
		mPrefTextSizeT = mSharedPref.getInt(MyPref.KEY_TEXTSIZETE, MyPref.VAL_TEXTSIZETE);
		mPrefTextSizeB = mSharedPref.getInt(MyPref.KEY_TEXTSIZEBE, MyPref.VAL_TEXTSIZEBE);
		mPrefTextType = mSharedPref.getInt(MyPref.KEY_TEXTTYPE, MyPref.VAL_TEXTTYPE);
		mPrefMarkerDefault = mSharedPref.getInt(SharePref.KEY_MARKER_DEFAULT_ID, MyPref.VAL_MARKER_DEFAULT_ID);
		mPrefMarkerLinked = mSharedPref.getString(SharePref.KEY_MARKER_LINKTOLABEL, SharePref.VAL_MARKER_LINKTOLABEL);
		mPrefHyperlinkEnabled = mSharedPref.getBoolean(SharePref.KEY_HYPERLINK_ENABLED, SharePref.VAL_HYPERLINK_ENABLED);
		
		initContentView();
		
		iv_mode.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				Intent i = new Intent(ViewEntryBackup.this, EditEntry.class);
				i.putExtra(Intent1.EXTRA_ENTRY_ID, mExtraEntryId);
				startActivity(i);
			}
        });
		
		iv_star.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (mIcon.mListIconidEnabled == null || mIcon.mListIconidEnabled.size()==0) {
					Toast.makeText(ViewEntryBackup.this, R.string.share_m_icon_no_available, Toast.LENGTH_LONG).show();
				}
				else {
					removeDialog(DIA_MARKER);
					showDialog(DIA_MARKER);
				}
			}
        });
        
		tv_folder.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				removeDialog(DIA_FLD_LST);
				showDialog(DIA_FLD_LST);
			}
        });
		
        tv_tag.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				removeDialog(DIA_TAG_LST);
				showDialog(DIA_TAG_LST);
			}
        });

        
        tv_rem.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				long id = mExtraEntryId;
				long time = mED.remindertime;
				int type = mED.remindertype;
				mReminder.launchAlarmPickr(id, time, type);
			}
        });
        
        iv_add.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				showDialog(DIA_INS_ITEM);
			}
        });
        
        ga_01.setOnItemClickListener(new OnItemClickListener() {
            public void onItemClick(AdapterView parent, View v, int position, long id) {
            	mSelectedItemPosition = position;
            	mItemCursor.moveToPosition(position);
            	mID = new ItemData(mItemCursor);
            	
            	if (mItem1.isExist(mID.type, mID.fileFullPath)) {
            		Multimedia.launchViewer(ViewEntryBackup.this, mID);
            	}
            	else {
            		showDialog(DIA_ITEM_INCONSISTENCY);
            	}
            }
        });
		
		ga_01.setOnCreateContextMenuListener(new OnCreateContextMenuListener() {
			public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
				
				AdapterView.AdapterContextMenuInfo info;
				try {
					info = (AdapterView.AdapterContextMenuInfo) menuInfo;
				} 
				catch (ClassCastException e) {
					//if (Global.DEBUG) Log.e("XXX", "bad menuInfo", e);
					return;
				}
				
				mSelectedItemPosition = info.position;
				mItemCursor.moveToPosition(mSelectedItemPosition);
				mID = new ItemData(mItemCursor);
				
            	if (mItem1.isExist(mID.type, mID.fileFullPath)) {
            		
            		if (mID.title==null || mID.title.length()==0)
            			menu.setHeaderTitle(R.string.share_no_title);
            		else 
            			menu.setHeaderTitle(mID.title);
            		
            		menu.add(0, CMENU_ITEM_VIEW, 0, R.string.share_view);
    				menu.add(0, CMENU_ITEM_VIEW_INFO, 0, R.string.share_m_item_detail);
    				menu.add(0, CMENU_ITEM_DEL, 0, R.string.share_delete);
    				
    				if (mID.type==ItemOper.TYPE_TASK || mID.type==ItemOper.TYPE_EXPN) {
    					// do nothing
    				}
    				else {
    					menu.add(0, CMENU_ITEM_SEND, 0, R.string.share_share);
    				}
    				
    				if (mID.type==ItemOper.TYPE_PHOTO || mID.type==ItemOper.TYPE_IMAGE) {
						menu.add(0, CMENU_ITEM_REGEN, 0, R.string.share_regen_thumb);
					}
            	}
            	else {
            		showDialog(DIA_ITEM_INCONSISTENCY);
            	}
			}
        });
		
        
        if (mIsInArray) {
        	mExtraEntryId = mExtraNoteIdArray[mExtraNotePosition];
        }
        
		mDbHelper.open();
		
		mLabel1 = new LabelOper(this,mDbHelper);
		mLabel2 = new LabelOper2(this,mDbHelper);
		mTagData = mLabel1.getAllLable();
		mFldData = mLabel2.getAllLable(LabelOper2.TYPE_FLD, 1);
		
		new MyDemoUtils(this).showPopup(false);
		
		sv_01.scrollTo(0, 0);
		
        if (MyApp.DEBUG) Log.e(TAG,"onCreate-end");
    }
    
    @Override
	protected void onResume() {
    	super.onResume();
    	if (MyApp.DEBUG) Log.e(TAG,"onResume-start");
    	mforceCloseThread=false;
    	loadPreferences();

        for (int i=0; i<SCREEN_ELEM_COUNT; i++) 
        	showhideElem(i,mScreenElems[i]);
        
        if (mExtraEntryId==-1L) {	// for the new entries, go and get the content
        	launchPickrPre(mExtraItemType);
        }
        else {
        	
        	preprocessing001();
        	
        	refreshNote();
        	refreshGa01();
//        	refreshGa01Thumbnail();
      		refreshPrevNextButton();
        }
	}
    
    
    @Override
	protected void onPause() {
    	if (MyApp.DEBUG) Log.e(TAG,"onPause");
    	mforceCloseThread=true;
    	super.onPause();
	}
	
    @Override
	protected void onDestroy() {
    	if (MyApp.DEBUG) Log.e(TAG,"onDestroy");
    	if (mItemCursor!=null) 	mItemCursor.close();
    	mDbHelper.close();
		super.onDestroy();
	}
    
    public void loadPreferences() {
    	
    	for (int i=0; i<SCREEN_ELEM_COUNT; i++)
    		mScreenElems[i] = mSharedPref.getBoolean(SCREEN_ELEMS_PREF[i], true);
		
    	mPrefTaskSortOrder = mSharedPref.getInt(SharePref.KEY_TASK_HEADER_SORT_ORDER, SharePref.VAL_TASK_HEADER_SORT_ORDER);
		mPrefExpnSortOrder = mSharedPref.getInt(SharePref.KEY_EXPN_HEADER_SORT_ORDER, SharePref.VAL_EXPN_HEADER_SORT_ORDER);
		mPrefThumbChoice = mSharedPref.getInt(SharePref.KEY_THUMBNAIL_CHOICE, SharePref.VAL_THUMBNAIL_CHOICE);
    }
    
    @Override 
    public void onSaveInstanceState(Bundle outState) {
    	
        if (MyApp.DEBUG) Log.e(TAG,"onSaveInstanceState");
//    	outState.putLong("mExtraNoteId",mExtraNoteId);
    }
    
    @Override
    public void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        if (MyApp.DEBUG) Log.e(TAG,"onRestoreInstanceState");
//        mExtraNoteId = savedInstanceState.getLong("mExtraNoteId");
//        mLabel = savedInstanceState.getString("mLabel");
    }
    
    @Override
	public void onConfigurationChanged(Configuration newConfig) {
        if (MyApp.DEBUG) Log.e(TAG,"onConfigurationChanged");
    	super.onConfigurationChanged(newConfig);
    	
    	if (mED!=null) {
        	refreshDateTime();
    	}
    	removeDialogs();
	}
    
    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
        menu.add(0, MENU_ITEM_EDIT, 1, R.string.share_edit)
        .setIcon(R.drawable.ic_menud_edit);
		menu.add(0, MENU_ITEM_DEL_NOTE, 2, R.string.share_delete)
        .setIcon(R.drawable.ic_menud_delete);
		menu.add(0, MENU_ITEM_TAG, 3, R.string.share_tag)
        .setIcon(R.drawable.ic_menud_tag);

        SubMenu helpMenu = menu.addSubMenu(0, MENU_ITEM_SUB0, 4, R.string.common1_rematt)
		.setIcon(R.drawable.ic_menud_attrem);
		helpMenu.add(0, MENU_ITEM_ATTACH, 3, R.string.share_attachment);
		helpMenu.add(0, MENU_ITEM_REMINDER, 4, R.string.share_reminder);

		menu.add(0, MENU_ITEM_SHARE, 5, R.string.share_share)
        .setIcon(R.drawable.ic_menud_share);
        menu.add(0, MENU_ITEM_DISP_OPTION, 6, R.string.share_scr_settings)
        .setIcon(R.drawable.ic_menud_scr_setting);
        
		
        return true;
	}

	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
		super.onPrepareOptionsMenu(menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		Intent i = new Intent();
		
		switch (item.getItemId()) {
//		case MENU_ITEM_GPS:
//			i.setClass(this, LocationPickr.class);
//        	startActivity(i);
//			break;
		case MENU_ITEM_SHARE:
			removeDialog(DIA_SHARE_SNG);
			showDialog(DIA_SHARE_SNG);
			break;
		case MENU_ITEM_EDIT:
			i.setClass(this, EditEntry.class);
        	i.putExtra(Intent1.EXTRA_ENTRY_ID, mExtraEntryId);
        	startActivity(i);
			break;
		case MENU_ITEM_DEL_NOTE:
			showDialog(DIA_DEL_NOTE);
			break;
		case MENU_ITEM_TAG:
			removeDialog(DIA_TAG_LST);
			showDialog(DIA_TAG_LST);
			break;
		case MENU_ITEM_REMINDER:
			long id = mExtraEntryId;
			long time = mED.remindertime;
			int type = mED.remindertype;
			mReminder.launchAlarmPickr(id, time, type);
			break;
		case MENU_ITEM_DISP_OPTION:
			showDialog(DIA_DISP_OPTION);
			break;
		case MENU_ITEM_ATTACH:
			showDialog(DIA_INS_ITEM);
			break;
		}

		return true;
	}
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
    	
		switch(item.getItemId()) {
		case CMENU_ITEM_VIEW:
			Multimedia.launchViewer(this, mID);
			break;
		case CMENU_ITEM_VIEW_INFO:
			showDialog(DIA_VIEW_ITEM);
			break;
		case CMENU_ITEM_DEL:
			if (	mID.type==ItemOper.TYPE_PHOTO || 
					mID.type==ItemOper.TYPE_IMAGE ||  
					mID.type==ItemOper.TYPE_VOICE ||  
					mID.type==ItemOper.TYPE_AUDIO	)
				showDialog(DIA_DEL_ITEM_ALL);
			else
				showDialog(DIA_DEL_ITEM_LINK);
			break;
		case CMENU_ITEM_SEND:
			String subject = "";
			String message = "";
			ActivityLauncher al = new ActivityLauncher(this);
			if (mID.type==ItemOper.TYPE_PHOTO || mID.type==ItemOper.TYPE_IMAGE) {
				List<String> attach = new ArrayList<String>();
				attach.add(mID.fileFullPath);
				al.LaunchEmailWithImage(subject, message, attach);
			}
			else {
				File attach = new File(mID.fileFullPath);
				al.LaunchEmailWithFile(subject, message, attach);
			}
			
			break;
		case CMENU_ITEM_REGEN:
			
			File f1 = new File(mID.fileFullPath);
			File f3 = new File(MyApp.THUMB_DIR, mExtraEntryId+"_"+f1.getName());
			
			boolean result = IOUtils.rm(f3);
			refreshGa01();
			if (MyApp.DEBUG) Log.e(TAG, "re-generating thumb: "+mID.fileFullPath+", "+f3.isFile()+", "+result);

			if (f1.isFile() && !f3.isFile()) {
				mMissingThumbList = new ArrayList<String>();
				mMissingThumbList.add(mID.fileFullPath);
				new Thread() {
	    			@Override
	    			public void run() {
	    				generateThmBck();
	    				handler.sendEmptyMessage(HANDLER_LOAD_THUMB);
	    			}
	    		}.start();
			}
			
			break;
		}
		return true;
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
		super.onActivityResult(requestCode, resultCode, intent);
		if (MyApp.DEBUG) Log.e(TAG, "onActivityResult-start: requestCode:" + requestCode + ", resultCode: " + resultCode);
		if (MyApp.DEBUG) Log1.logViewNote1Intent2(TAG, intent);

		// if the photo is not taken, RESULT_CANCELLED/0 is returned in resultCode
		if (resultCode != RESULT_OK) {
			if (mExtraEntryId==-1L)	finish();
			return;
		}
		
		Uri uri=null;
		Bundle extras = null;
		switch (requestCode) {
		case ItemOper.TYPE_PHOTO:			// Photo doesn't care Uri and sends null intent
			launchPickrPost(uri, requestCode);
			break;
			
		case ItemOper.TYPE_IMAGE:
		case ItemOper.TYPE_VIDEO:
		case ItemOper.TYPE_VOICE:
		case ItemOper.TYPE_AUDIO:
			
			// if intent is null
			if (intent == null) {
				String s1 = "Error 200\nIntent not received";
				Toast.makeText(this, s1, Toast.LENGTH_LONG).show();
				return;
			}
			
			uri=intent.getData();
			// if there's no content uri
			if (uri==null) {
				String s1 = "Error 201\nContent uri not received";
				Toast.makeText(this, s1, Toast.LENGTH_LONG).show();
				return;
			}
			
			String uriString = uri.toString();
			if (uriString == null || uriString.length() == 0) {
				String s1 = "Error 202\nContent uri not received";
				Toast.makeText(this, s1, Toast.LENGTH_LONG).show();
				return;
			}

			// if everything is OK
			launchPickrPost(uri, requestCode);
			break;
			
		case ItemOper.TYPE_TEXT:
		case ItemOper.TYPE_TEMPLATE:
			extras = intent.getExtras();
	        if (extras != null) {
	        	mExtraEntryId = extras.getLong(Intent1.EXTRA_ENTRY_ID);
	        }
	        else {
	        	String s1 = "Error 203\nIntent,extra not received";
				Toast.makeText(this, s1, Toast.LENGTH_LONG).show();
	        }
			break;
		case ItemOper.TYPE_FILE:
			extras = intent.getExtras();
	        if (extras != null) {
	        	mGeneralFileFull = extras.getString(ShareIntent.EXTRA_GENERAL_FILE);
	        }
	        else {
	        	String s1 = "Error 204\nIntent,extra not received";
				Toast.makeText(this, s1, Toast.LENGTH_LONG).show();
	        }
			launchPickrPost(uri, requestCode);
			break;
			
		}
		
		if (MyApp.DEBUG) Log.e(TAG, "onActivityResult-end");
	}
	
    @Override
	protected Dialog onCreateDialog(int id) {
		switch (id) {
		case DIA_DEL_NOTE:				return buildDialog1301();
		case DIA_MARKER:				return buildDialog4100();
		case DIA_DISP_OPTION:			return buildDialog4();
		case DIA_SHARE_SNG:				return buildDialog4200();
		
		case DIA_TAG_INS:				return buildDialog4107();
		case DIA_TAG_LST:				return buildDialog3300();
		case DIA_FLD_INS:				return buildDialog4102();
		case DIA_FLD_LST:				return buildDialog3211();
		
		case DIA_INS_ITEM:				return buildDialog2();
		case DIA_ITEM_INCONSISTENCY:	return buildDialog1401();
		case DIA_DEL_ITEM_LINK:			return buildDialog1300();
		case DIA_DEL_ITEM_ALL:			return buildDialog1302();
		case DIA_VIEW_ITEM:				return buildDialog23();

		case DIA_TASK_PICKR:			return buildDialog106();
		case DIA_EXPN_PICKR:			return buildDialog306();
		case DIA_TASKEXPN_NEW:			return buildDialog4103();
		
//		case DIA_DATE:					return buildDialog2100();
//		case DIA_TIME:					return buildDialog2200();
		
		
		}
		return null;
	}

	@Override
	protected void onPrepareDialog(int id, Dialog dialog) {
		
//		Calendar c = Calendar.getInstance();
		String message;
		switch (id) {
		case DIA_ITEM_INCONSISTENCY:
			if (mID.type==ItemOper.TYPE_TASK || mID.type==ItemOper.TYPE_EXPN) {
				((AlertDialog)dialog).setTitle(R.string.noteedit_file_not_found);
				message = getString(R.string.noteedit_no_general);
				((AlertDialog)dialog).setMessage(message);
			}
			else {
				((AlertDialog)dialog).setTitle(R.string.noteedit_file_not_found);
				message = getString(R.string.noteedit_no_attachment).replace("xxxxx", mID.fileFullPath);
				((AlertDialog)dialog).setMessage(message);
			}
			break;
//		case DIA_DATE:
//			c.setTimeInMillis(mED.created);
//			((MsDatePickerDialog) dialog).updateDate(
//					c.get(Calendar.YEAR), 
//					c.get(Calendar.MONTH), 
//					c.get(Calendar.DAY_OF_MONTH));
//			break;
//		case DIA_TIME:
//			c.setTimeInMillis(mED.created);
//			((MsTimePickerDialog) dialog).updateTime(
//					c.get(Calendar.HOUR_OF_DAY), 
//					c.get(Calendar.MINUTE));
//			break;
		case DIA_VIEW_ITEM:
			refreshItemDetail();
			break;
		case DIA_TAG_INS:	
			dia7_et_label.setText("");
			break;
		case DIA_FLD_INS:	
			dia2_et_label.setText("");
			break;
		}
	}
	
	// date picker
	public void showDialogDatePicker() {
		
		boolean vibrate = true;
		
		if (mDatePickerDialog==null) {
			mDatePickerDialog = DatePickerDialog02.newInstance(
				new DatePickerDialog02.OnDateSetListener() {
					@Override
					public void onDateSet(DatePickerDialog02 datePickerDialog, int year, int month, int day) {
						mED.created = DateUtils1.resetDateTime(mED.created, year, month, day, -1, -1);
				        int updateCount = mEntry1.updateNoteCreated(mExtraEntryId, mED.created);
				    	if (updateCount>0) {
				    	}
				    	else {
			        		Toast.makeText(ViewEntryBackup.this, R.string.share_update_failed, Toast.LENGTH_SHORT).show();
			        	}
				    	
				    	if (menuTriggered) 	showDialogTimePicker();
				        refreshDateTime();
					}

					@Override
					public void onDateInit() {
//						Toast.makeText(EditEntry.this, "onDateInit", Toast.LENGTH_LONG).show();
					}
				},
				1999, 2, 28, vibrate);
			mDatePickerDialog.setButtons(true, false, true);
		}
		
		Calendar c = Calendar.getInstance();
		c.setTimeInMillis(mED.created);
		
		mDatePickerDialog.setDate(
				c.get(Calendar.YEAR), 
				c.get(Calendar.MONTH), 
				c.get(Calendar.DAY_OF_MONTH));
		
		mDatePickerDialog.show(getSupportFragmentManager(), "mDatePickerDialog");
		
		
	}
	
	// time picker
	public void showDialogTimePicker() {
		
		if (mTimePickerDialog==null) {
			mTimePickerDialog = TimePickerDialog03.newInstance(
				new TimePickerDialog03.OnTimeSetListener() {

					@Override
					public void onTimeSet(int hourOfDay, int minute) {
						mED.created =DateUtils1.resetDateTime(mED.created, -1, -1, -1, hourOfDay, minute);
				        int updateCount = mEntry1.updateNoteCreated(mExtraEntryId, mED.created);
				    	if (updateCount>0) {
				    	}
				    	else {
			        		Toast.makeText(ViewEntryBackup.this, R.string.share_update_failed, Toast.LENGTH_SHORT).show();
			        	}
				        refreshDateTime();
					}

					@Override
					public void onTimeInit() {	}
				},
				11, 59, MyApp.TIME_FORMAT==1, true);
			mTimePickerDialog.setButtons(true, false, true);
		}
		
		Calendar c = Calendar.getInstance();
		c.setTimeInMillis(mED.created);
	
		mTimePickerDialog.setStartTime(
				c.get(Calendar.HOUR_OF_DAY), 
				c.get(Calendar.MINUTE));

		mTimePickerDialog.show(getSupportFragmentManager(), "mTimePickerDialog");
		
		
	}
	
	// New tag
	private EditText dia7_et_label;
	
	public AlertDialog buildDialog4107() {
		LayoutInflater li = LayoutInflater.from(this);
		View v = li.inflate(R.layout.diag_et1, null);
		dia7_et_label = (EditText) v.findViewById(R.id.et_01);
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_new_tag)
		.setView(v)
		.setPositiveButton(
				R.string.share_save, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {

				    	String title = dia7_et_label.getText().toString();
			    		processTagNew(title);
			    		
				    }
	        	})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	// New folder
	private EditText dia2_et_label;
	
	public AlertDialog buildDialog4102() {
		LayoutInflater li = LayoutInflater.from(this);
		View v = li.inflate(R.layout.diag_et1, null);
		dia2_et_label = (EditText) v.findViewById(R.id.et_01);
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_new_folder)
		.setView(v)
		.setPositiveButton(
				R.string.share_save, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	String title = dia2_et_label.getText().toString();
				    	processFolderNew(title);
				    }
	        	})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	public Dialog buildDialog4200() {
		return mEntry1.buildExportSingleDialog(mExtraEntryId);
	}

	// icon picker
	public AlertDialog buildDialog4100() {
		
		int[] iconRes = Icon.ICON_DRAWABLE_RES;
		String[] iconDesc = mIcon.mIconDesc;
		List<Integer> iconEnabled = mIcon.mListIconidEnabled;
		int iconSelected = mED.marker;
		String title = getString(R.string.share_icons);
		
		return new IconAlertDialog(
				this, title, iconRes, iconDesc, iconEnabled, iconSelected, 
				new OnIconDialogListener() {
					public void onSelected(IconAlertDialog dialog, int iconid) {
						mED.marker = iconid;
						iv_star.setImageResource(Icon.ICON_DRAWABLE_RES[mED.marker]);
						int updateCount = mEntry1.updateNoteEmoticon(mExtraEntryId, mED.marker);
					}
				});
	}

	
	// Hopeless image
	public AlertDialog buildDialog35() {
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.noteedit_hopeless_image)
		.setMessage("")
		.setNeutralButton(
				R.string.share_delete, 
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int whichButton) {
						
						int deleteCount = mItem1.deleteAttachWithOrig(mID);
		        		if (deleteCount > 0) {
						} 
						else {
							Toast.makeText(ViewEntryBackup.this,R.string.noteedit_item_del_failed,Toast.LENGTH_LONG).show();
						}
//		        		if (mItemCursor!=null) mItemCursor.requery();
//        				refreshGa01Backupground();
		        		mSelectedItemPosition--;
		        		refreshGa01();
//		            	refreshGa01Thumbnail();
//		          		refreshPrevNextButton();
					}
				});
		return dialogB.create();
	}
	
	// Attach task list
	public AlertDialog buildDialog106() {

		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_task)
		.setCursor(
				mCursorTask, 
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						mCursorTask.moveToPosition(which);
						mGeneralFileFull = mCursorTask.getLong(0) + "";
						launchPickrPost(null, ItemOper.TYPE_TASK);
					}
				}, 
				DBAdapter.FLD_TASK_TITLE)
		.setPositiveButton(R.string.share_add, new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int whichButton) {
				mDiaTaskExpnType=0;
				removeDialog(DIA_TASKEXPN_NEW);
				showDialog(DIA_TASKEXPN_NEW);
			}
		})
		.setNegativeButton(R.string.share_close, null);

		return dialogB.create();
	}
	
	// Attach expense list
	public AlertDialog buildDialog306() {

		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_expense)
		.setCursor(
				mCursorExpn, 
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						mCursorExpn.moveToPosition(which);
						mGeneralFileFull = mCursorExpn.getLong(0) + "";
						launchPickrPost(null, ItemOper.TYPE_EXPN);
					}
				}, 
				DBAdapter.FLD_TASK_TITLE)
		.setPositiveButton(R.string.share_add, new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int whichButton) {
				mDiaTaskExpnType=1;
				removeDialog(DIA_TASKEXPN_NEW);
				showDialog(DIA_TASKEXPN_NEW);
			}
		})
		.setNegativeButton(R.string.share_close, null);

		return dialogB.create();
	}
	
	// New task expense
	private int mDiaTaskExpnType;
	
	public AlertDialog buildDialog4103() {
		LayoutInflater li = LayoutInflater.from(this);
		View v = li.inflate(R.layout.diag_et1, null);
		final EditText dia_et_label = (EditText) v.findViewById(R.id.et_01);
		
		String title = (mDiaTaskExpnType==0) ? "New task list" : "New expense list";
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(title)
		.setView(v)
		.setPositiveButton(
				R.string.share_save, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {

				    	String title = dia_et_label.getText().toString();

				    	if (mDiaTaskExpnType==0) {
					    	Task1 task = new Task1(ViewEntryBackup.this, mDbHelper);
							long due = System.currentTimeMillis();
					    	long taskid = task.createTaskHeader(title, due);
					    	
					    	if (taskid>0) {
						    	long objid = mExtraEntryId;
						    	String title1 = getString(R.string.share_task);
								String fileuri = taskid+"";
								int type = ItemOper.TYPE_TASK;
								long itemId = mDbHelper.createItem(objid, title1, fileuri, type);
								if (itemId>0) {
									mItemCursor.requery();
									mSelectedItemPosition = mItemCursor.getCount()-1;
							    	Intent i = new Intent(ViewEntryBackup.this, ListTaskItem.class);
					            	i.putExtra(ShareIntent.EXTRA_TODO_HEADERID, taskid);
					            	startActivity(i);
								}
					    	}
				    	}
				    	else {
				    		Expense expn = new Expense(ViewEntryBackup.this, mDbHelper);
							long due = System.currentTimeMillis();
					    	long expnid = expn.createExpenseHeader(title, due);
					    	if (expnid>0) {
						    	long objid = mExtraEntryId;
						    	String title1 = getString(R.string.share_expense);
								String fileuri = expnid+"";
								int type = ItemOper.TYPE_EXPN;
								long itemId = mDbHelper.createItem(objid, title1, fileuri, type);
								if (itemId>0) {
									mItemCursor.requery();
									mSelectedItemPosition = mItemCursor.getCount()-1;
									Intent i = new Intent(ViewEntryBackup.this, ListExpnItem.class);
							    	i.putExtra(ShareIntent.EXTRA_TODO_HEADERID, expnid);
					            	startActivity(i);
								}
					    	}
				    	}
				    }
	        	})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	
	// Disp screen element
	public AlertDialog buildDialog4() {
		AlertDialog.Builder builder = new AlertDialog.Builder(this)
		.setTitle(R.string.share_screen_settings)
        .setMultiChoiceItems(
        		R.array.screen_elements_desc,
        		mScreenElems,
        		new DialogInterface.OnMultiChoiceClickListener() {
                public void onClick(DialogInterface dialog, int whichButton, boolean isChecked) {
                	mSharedPrefEdit.putBoolean(SCREEN_ELEMS_PREF[whichButton], isChecked);	
                	mSharedPrefEdit.commit();
                	showhideElem(whichButton, isChecked);
                }
            })
		.setNegativeButton(R.string.share_close, null);
		return builder.create();
	}
	
	// delete note
	public AlertDialog buildDialog1301() {
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_delete)
		.setMessage(R.string.common1_delete_entry_msg)
		.setPositiveButton(
				R.string.share_ok, 
				new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog, int whichButton) {
			    	int updateCount = mEntry1.trashNote(mExtraEntryId);
			    	if (updateCount>0) {
			    		finish();
			    	}
			    	else {
			    		Toast.makeText(ViewEntryBackup.this, R.string.share_delete_failed, Toast.LENGTH_SHORT).show();
			    	}
			    	
			    }
			})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	// Change date
//	public MsDatePickerDialog buildDialog2100() {
//		return new MsDatePickerDialog(
//			this, 
//			new MsDatePickerDialog.OnDateSetListener() {
//				public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
//					mED.created = DateUtils1.resetDateTime(mED.created, year, monthOfYear, dayOfMonth, -1, -1);
//			        int updateCount = mEntry1.updateNoteCreated(mExtraEntryId, mED.created);
//			    	if (updateCount>0) {
//			    	}
//			    	else {
//		        		Toast.makeText(ViewEntry.this, R.string.share_update_failed, Toast.LENGTH_SHORT).show();
//		        	}
//			    	
//			    	if (menuTriggered) 	showDialog(DIA_TIME);
//			        refreshDateTime();
//				}
//			}, 
//			1999, 2, 28);
//	}
//	
//	public MsTimePickerDialog buildDialog2200() {
//		return new MsTimePickerDialog(
//			this,
//			new MsTimePickerDialog.OnTimeSetListener() {
//				public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
//					mED.created =DateUtils1.resetDateTime(mED.created, -1, -1, -1, hourOfDay, minute);
//			        int updateCount = mEntry1.updateNoteCreated(mExtraEntryId, mED.created);
//			    	if (updateCount>0) {
//			    	}
//			    	else {
//		        		Toast.makeText(ViewEntry.this, R.string.share_update_failed, Toast.LENGTH_SHORT).show();
//		        	}
//			        refreshDateTime();
//				}
//			},
//			11,59,MyApp.TIME_FORMAT==1);
//	}
	
	// Notice Task list not available
	public AlertDialog buildDialog1401() {
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.noteedit_file_not_found)
		.setMessage(R.string.noteedit_no_attachment)
		.setPositiveButton(
				R.string.share_delete, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	int deleteCount = mItem1.deleteAttachWithOrig(mID);
		        		if (deleteCount > 0) {
						} 
						else {
							Toast.makeText(ViewEntryBackup.this,R.string.share_delete_failed,Toast.LENGTH_LONG).show();
						}
        				mSelectedItemPosition--;
						refreshGa01();
				    }
				})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	
	// Delete item
	public AlertDialog buildDialog1300() {
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_delete)
		.setMessage(R.string.noteedit_item_del_msg)
		.setPositiveButton(
				R.string.share_delete_link, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	int deleteCount = mItem1.deleteAttachLink(mID);
		        		if (deleteCount > 0) {
						} 
						else {
		    				Toast.makeText(ViewEntryBackup.this,R.string.share_delete_failed,Toast.LENGTH_LONG).show();
						}
        				mSelectedItemPosition--;
        				refreshGa01();
				    }
				})
		.setNeutralButton(
				R.string.share_delete_all, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	int deleteCount = mItem1.deleteAttachWithOrig(mID);
		        		if (deleteCount > 0) {
						} 
						else {
							Toast.makeText(ViewEntryBackup.this,R.string.share_delete_failed,Toast.LENGTH_LONG).show();
						}
        				mSelectedItemPosition--;
        				refreshGa01();
				    }
				})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	// Delete item
	public AlertDialog buildDialog1302() {
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_delete)
		.setMessage(R.string.share_m_dia_item_will_delete)
		.setPositiveButton(
				R.string.share_ok, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	int deleteCount = mItem1.deleteAttachWithOrig(mID);
		        		if (deleteCount > 0) {
						} 
						else {
							Toast.makeText(ViewEntryBackup.this,R.string.share_delete_failed,Toast.LENGTH_LONG).show();
						}
        				mSelectedItemPosition--;
        				refreshGa01();
				    }
				})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	
	// Add tags
	// need to be re-instantiated
	public AlertDialog buildDialog3300() {
		
		List<String> tagList = mEntry1.getTagList(mExtraEntryId);
		mTagData.refreshStatMulti(tagList);
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_tag)
		.setMultiChoiceItems(
				mTagData.getArrayTitle(),
				mTagData.getArrayStat(),
        		new DialogInterface.OnMultiChoiceClickListener() {
                public void onClick(DialogInterface dialog, int whichButton, boolean isChecked) {
                	mTagData.mList.get(whichButton).stat = isChecked;
                }
            })
	   .setPositiveButton(
				R.string.share_save,  
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	boolean updateIcon = (MyApp.PRF_MARKER_ENABLED && mPrefMarkerLinked.equals("1"));
				    	mEntry1.updateNoteTag(mTagData, mExtraEntryId, updateIcon);
				    	
				    	if (updateIcon) {
				    		int count = mTagData.mList.size();
				    		for (int i=0; i<count; i++) {
				    			if (mTagData.mList.get(i).stat) {
				    				mED.marker = mTagData.mList.get(i).icon;
				    				break;
				    			}
				    		}
	                		if (mED.marker>=0) {
	                			iv_star.setImageResource(Icon.ICON_DRAWABLE_RES[mED.marker]);
	                		}
				    	}
				    	
//				    	if (MyApp.PRF_MARKER_ENABLED && mPrefMarkerLinked.equals("1")) {
//				    		int count = mTagData.mList.size();
//				    		for (int i=0; i<count; i++) {
//				    			if (mTagData.mList.get(i).stat) {
//				    				mED.marker = mTagData.mList.get(i).icon;
//				    				break;
//				    			}
//				    		}
//	                		if (mED.marker>=0) {
//	                			mEntry1.updateNoteEmoticon(mExtraEntryId, mED.marker);
//	                			iv_star.setImageResource(Icon.ICON_DRAWABLE_RES[mED.marker]);
//	                		}
//	                	}
				    	
				    	refreshRemTag();
					}
		        })
		.setNeutralButton(
   				R.string.share_add,  
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	showDialog(DIA_TAG_INS);
					}
		        })
       .setNegativeButton(R.string.share_close, null);
		return dialogB.create();
	}
	
	// tv_folder
	public AlertDialog buildDialog3211() {
		
		mFldData = mLabel2.getAllLable(LabelOper2.TYPE_FLD, 1);
		mFldData.refreshStatSingle(mED.folderid);
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_folder)
		.setSingleChoiceItems(
				mFldData.getArraySemiPath(),
				mFldData.position, 
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						mFldData.position = which;
					}
				})
   		.setPositiveButton(
   				R.string.share_save,  
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	long fromId = mED.folderid;
				    	long toId = mFldData.mList.get(mFldData.position).id;
				    	if (fromId!=toId) {
				    		mEntry1.updateNoteFolder(mED.id, toId);
				    		mED.folderid = toId;
							refreshFolder();
				    	}
					}
		        })
        .setNeutralButton(
   				R.string.share_add,  
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	showDialog(DIA_FLD_INS);
					}
		        })
		.setNegativeButton(R.string.share_cancel,  null);
		return dialogB.create();
	}
	
	// Insert attachemnt
	public Dialog buildDialog2() {
		
		LayoutInflater factory = LayoutInflater.from(this);
		final View v = factory.inflate(R.layout.diag_gv, null);
		GridView gv_01 = (GridView) v.findViewById(R.id.gv_01);
		
		gv_01.setAdapter(new BaseAdapterIconList(this,1,-1));
		gv_01.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView parent, View v, int position, long id) {
				launchPickrPre(position);
				dismissDialog(DIA_INS_ITEM);
			}
		});
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle(R.string.share_attachment)
		.setView(v)
		.setNegativeButton(R.string.share_close,  null);
		
		return dialogB.create();
		
	}
	
	
	// attached item preview
	ImageView dia23_iv_thumbnail;
	TextView dia23_tv_title;
	TextView dia23_tv_content;
	boolean mDiaContentFound;
	
	public AlertDialog buildDialog23() {
		LayoutInflater factory = LayoutInflater.from(this);
		final View v = factory.inflate(R.layout.shr_dia_attach_preview, null);

		dia23_iv_thumbnail = (ImageView) v.findViewById(R.id.iv_thumbnail);
		dia23_tv_title = (TextView) v.findViewById(R.id.tv_title);
		dia23_tv_content = (TextView) v.findViewById(R.id.tv_content);
		
		AlertDialog.Builder builder = new AlertDialog.Builder(this)
			.setTitle(R.string.share_m_item_detail)
			.setView(v)
			.setPositiveButton(
					R.string.share_view,	
					new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int whichButton) {
							if (mDiaContentFound) {	
								Multimedia.launchViewer(ViewEntryBackup.this, mID);
							}
							else {
								Toast.makeText(ViewEntryBackup.this, "Cannot find attached file", Toast.LENGTH_SHORT).show();
							}
						}
					})
			.setNeutralButton(
					R.string.share_delete, 
					new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int whichButton) {
							if (mDiaContentFound) {	
								if (	mID.type==ItemOper.TYPE_PHOTO || 
										mID.type==ItemOper.TYPE_IMAGE ||  
										mID.type==ItemOper.TYPE_VOICE ||  
										mID.type==ItemOper.TYPE_AUDIO	)
									showDialog(DIA_DEL_ITEM_ALL);
								else
									showDialog(DIA_DEL_ITEM_LINK);
							}
							else {
						    	int deleteCount = mItem1.deleteAttachWithOrig(mID);
				        		if (deleteCount > 0) {
				    				Toast.makeText(ViewEntryBackup.this,R.string.share_delete_success,Toast.LENGTH_LONG).show();
								} 
								else {
									Toast.makeText(ViewEntryBackup.this,R.string.share_delete_failed,Toast.LENGTH_LONG).show();
								}
		        				mSelectedItemPosition--;
		        				refreshGa01();
							}
						}
					})
			.setNegativeButton(R.string.share_close, null);
		return builder.create();
	}
	
	public void refreshItemDetail() {
		
		mDiaContentFound = false;
		String title = mID.title;
		String output = "";
		
		switch (mID.type) {
		case ItemOper.TYPE_PHOTO:
		case ItemOper.TYPE_IMAGE:
			if (mID.fileFullPath!=null && mID.fileFullPath.length()>0) {
				
				String displayFileFullPath = mID.fileFullPath.replaceAll(MyApp.ROOT_DIR, "");
				if (MyApp.DEBUG) displayFileFullPath = mID.fileFullPath;
				
				File f1 = new File(mID.fileFullPath);
				if (f1.isFile()) {
					
					String imageSize = "";
					Bitmap bm = BitmapFactory.decodeFile(mID.fileFullPath);
					if (bm!=null) {
						imageSize = bm.getWidth()+" x "+bm.getHeight();
					}
					else {
						imageSize = "Not available";
					}
					bm.recycle();
					
					String fileTime = DateUtils1.getFullDTString(
							ViewEntryBackup.this, 
							f1.lastModified(), 
							MyApp.DATE_FORMAT, MyApp.TIME_FORMAT, "E", "h:mm",
							true, false, true);
					String fileSize = Util.getSizeString((float) f1.length());
					
					String fileInfo = 
							"<font color='#bbbbbb'>"+getString(R.string.share_image_size)+": </font>" + imageSize + "<br>" +
							"<font color='#bbbbbb'>"+getString(R.string.share_size)+": </font>" + fileSize + "<br>" +
							"<font color='#bbbbbb'>"+getString(R.string.share_time)+": </font>" + fileTime + "<br>" + 
							"<font color='#bbbbbb'>"+getString(R.string.share_file)+": </font><br>" + displayFileFullPath;
					
					mDiaContentFound = true;
					output = fileInfo;
				}
				else {
					output = 
						"<font color='#bbbbbb'>"+getString(R.string.share_file)+": </font><br>" + displayFileFullPath+"<br><br>"+
						getString(R.string.noteedit_no_attachment);
				}
			}
			else {
				output = 
					getString(R.string.share_file)+": "+mID.fileFullPath+"<br><br>"+
					getString(R.string.noteedit_no_attachment);
			}
			break;
		case ItemOper.TYPE_VIDEO:						// Video
		case ItemOper.TYPE_VOICE:
		case ItemOper.TYPE_AUDIO:
			if (mID.fileFullPath!=null && mID.fileFullPath.length()>0) {
				
				String displayFileFullPath = mID.fileFullPath.replaceAll(MyApp.ROOT_DIR, "");
				
				File f = new File(mID.fileFullPath);
				if (f.isFile()) {
					int duration = Multimedia.getDuration(mID.fileFullPath);
					
					String fileTime = DateUtils1.getFullDTString(
							ViewEntryBackup.this, 
							f.lastModified(), 
							MyApp.DATE_FORMAT, MyApp.TIME_FORMAT, "E", "h:mm",
							true, false, true);
					String fileDuration = Util.getDurationString(duration);
					String fileSize = Util.getSizeString((float) f.length());
					
					mDiaContentFound = true;
					output = 
							"<font color='#bbbbbb'>"+getString(R.string.share_size)+": </font>" + fileSize + "<br>" +
							"<font color='#bbbbbb'>"+getString(R.string.noteedit_duration)+": </font>" + fileDuration + "<br>" + 
							"<font color='#bbbbbb'>"+getString(R.string.share_time)+": </font>" + fileTime + "<br>" + 
							"<font color='#bbbbbb'>"+getString(R.string.share_file)+": </font><br>" + displayFileFullPath;
					
				}
				else {
					output = 
						"<font color='#bbbbbb'>"+getString(R.string.share_file)+": </font><br>" + displayFileFullPath+"<br><br>"+
						getString(R.string.noteedit_no_attachment);
				}
			}
			else {
				output = 
					getString(R.string.share_file)+": "+mID.fileFullPath+"<br><br>"+
					getString(R.string.noteedit_no_attachment);
			}
			break;
		case ItemOper.TYPE_FILE:
			if (mID.fileFullPath!=null && mID.fileFullPath.length()>0) {
				
				String displayFileFullPath = mID.fileFullPath.replaceAll(MyApp.ROOT_DIR, "");
				
				File f = new File(mID.fileFullPath);
				if (f.isFile()) {
					title = mID.fileFullPath.substring(mID.fileFullPath.lastIndexOf("/")+1);
					
					String fileTime = DateUtils1.getFullDTString(
							ViewEntryBackup.this, 
							f.lastModified(), 
							MyApp.DATE_FORMAT, MyApp.TIME_FORMAT, "E", "h:mm",
							true, false, true);
					String fileSize = Util.getSizeString((float) f.length());
					
					mDiaContentFound = true;
					output = 
							"<font color='#bbbbbb'>"+getString(R.string.share_size)+": </font>" + fileSize + "<br>" +
							"<font color='#bbbbbb'>"+getString(R.string.share_time)+": </font>" + fileTime + "<br>" + 
							"<font color='#bbbbbb'>"+getString(R.string.share_file)+": </font><br>" + displayFileFullPath;
				}
				else {
					output = 
						"<font color='#bbbbbb'>"+getString(R.string.share_file)+": </font><br>" + displayFileFullPath+"<br><br>"+
						getString(R.string.noteedit_no_attachment);
				}
			}
			else {
				output = 
					getString(R.string.share_file)+": "+mID.fileFullPath+"<br><br>"+
					getString(R.string.noteedit_no_attachment);
			}
			break;
		case ItemOper.TYPE_TASK:
			title = getString(R.string.share_tasks);
			
			if (mID.fileFullPath!=null && mID.fileFullPath.length()>0) {
				
				long listId = Long.parseLong(mID.fileFullPath);
				Task1 task = new Task1(this, mDbHelper);
				output = task.getInfo(0, listId);
				if (output!=null) {
					mDiaContentFound = true;
				}
				else {
					output = 
						getString(R.string.noteedit_todo_list)+"<br><br>"+
						getString(R.string.noteedit_no_attachment);
				}
				
			}
			else {
				output = 
					getString(R.string.noteedit_todo_list)+"<br><br>"+
					getString(R.string.noteedit_no_attachment);
			}
			break;
		case ItemOper.TYPE_EXPN:
			title = getString(R.string.share_expenses);
			
			if (mID.fileFullPath!=null && mID.fileFullPath.length()>0) {
				
				long listId = Long.parseLong(mID.fileFullPath);
				Expense expn = new Expense(this, mDbHelper);
				output = expn.getInfo(0, listId);
				
				if (output!=null) {
					mDiaContentFound = true;
				}
				else {
					output = 
						getString(R.string.noteedit_expense_list)+"<br><br>"+
						getString(R.string.noteedit_no_attachment);
				}
				
			}
			else {
				output = 
					getString(R.string.noteedit_expense_list)+"<br><br>"+
					getString(R.string.noteedit_no_attachment);
			}
			break;
		}

		dia23_iv_thumbnail.setImageResource(ItemOper.ITEM_ICON_RES[mID.type]);
		dia23_tv_title.setText(title);
		dia23_tv_content.setText(Html.fromHtml(output));

	}

	public void launchPickrPre(int requestCode) {
		if (MyApp.DEBUG) Log.e(TAG,"launchPickrPre ===============================");
		
		Intent i = new Intent();
		switch (requestCode) {
		case ItemOper.TYPE_TEMPLATE:	
		case ItemOper.TYPE_TEXT:	
			i.setClass(this, EditEntry.class);
			i.putExtra(Intent1.EXTRA_ENTRY_ID, -1L);
			i.putExtra(Intent1.EXTRA_ITEM_TYPE, mExtraItemType);	
			if (mExtraCreated>0)								i.putExtra(Intent1.EXTRA_NOTE_CREATED, mExtraCreated);
			if (mExtraMarker>=0)								i.putExtra(Intent1.EXTRA_NOTE_MARKERID, mExtraMarker);
			if (mExtraLabel!=null && mExtraLabel.length()>0)	i.putExtra(Intent1.EXTRA_LABEL_ID, mExtraLabel);
			i.putExtra(Intent1.EXTRA_FOLDER_ID, mExtraFolder);
			startActivityForResult(i,requestCode);
			break;
		case ItemOper.TYPE_PHOTO:			// photo
			// The caller may pass an extra EXTRA_OUTPUT to control where this image will be written. 
			// If the EXTRA_OUTPUT is not present, then a small sized image is returned as a Bitmap object in the extra field. 
			// This is useful for applications that only need a small image. 
			// If the EXTRA_OUTPUT is present, then the full-sized image will be written to the Uri value of EXTRA_OUTPUT.
			// We can check the result by checking the existance of file and resultCode in onActivityResult.
			
			mPhotoTime = System.currentTimeMillis();
			String photofilename = DateFormat.format("yyMMdd_kkmmss", mPhotoTime).toString()+".jpg";
			mPrefPhotoFilePath = MyApp.PHOTO_DIR+File.separator+photofilename;
			mSharedPrefEdit.putString(SharePref.KEY_ATTACH_PHOTO_FILE_PATH, mPrefPhotoFilePath);
			mSharedPrefEdit.commit();
			
			File f = new File(mPrefPhotoFilePath);
			Uri uri = Uri.fromFile(f);
			i.setAction(MediaStore.ACTION_IMAGE_CAPTURE);
			i.putExtra(MediaStore.EXTRA_OUTPUT, uri);
			startActivityForResult(i,requestCode);
			break;
		case ItemOper.TYPE_IMAGE:			// image
			i.setAction(Intent.ACTION_PICK);
			i.setData(MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
			startActivityForResult(i,requestCode);
			break;
		case ItemOper.TYPE_VIDEO:			// video
//			intent.setAction(MediaStore.ACTION_VIDEO_CAPTURE);
//			startActivityForResult(intent, mSelectedAttDocType);
//			break;
			i.setAction(Intent.ACTION_PICK);
			i.setType("video/*"); 
			startActivityForResult(i,requestCode);
			break;
		case ItemOper.TYPE_VOICE:			// voice
			
			boolean prefEnableInternalRec = mSharedPref.getBoolean(MyPref.KEY_ENABLE_INTERNAL_REC, MyPref.VAL_ENABLE_INTERNAL_REC);
			
			if (MyApp.DEBUG) Log.e(TAG, "Internal recorder: "+prefEnableInternalRec);
			if (prefEnableInternalRec) {
				mVoiceTime = System.currentTimeMillis();
				String voicefilename = DateFormat.format("yyMMdd_kkmmss", mVoiceTime).toString()+".3gpp";
				mVoiceFileFull = MyApp.VOICE_DIR+File.separator+voicefilename;
				
				// Embedded the Sound recorder inside the package.
				// No, uri pass required. 
				i.setClass(ViewEntryBackup.this, SoundRecorder.class);
				i.putExtra(ShareIntent.EXTRA_VOICE_FILE, mVoiceFileFull);
				startActivityForResult(i,requestCode);
				
			}
			else {
				try {
					// test: 2010-12-21 caused to invoke sound recorder
	//				if (MyApp.DEBUG) { 	throw new ActivityNotFoundException();	}
					i.setAction(MediaStore.Audio.Media.RECORD_SOUND_ACTION);
					startActivityForResult(i,requestCode);
				} 
				catch (Exception e) {
					mVoiceTime = System.currentTimeMillis();
					String voicefilename = DateFormat.format("yyMMdd_kkmmss", mVoiceTime).toString()+".3gpp";
//					mVoiceFileFull = MyApp.VOICE_DIR+File.separator+voicefilename;
					mVoiceFileFull = voicefilename;
					
					// Embedded the Sound recorder inside the package.
					// No, uri pass required. 
					i.setClass(ViewEntryBackup.this, SoundRecorder.class);
					i.putExtra(ShareIntent.EXTRA_VOICE_FILE, mVoiceFileFull);
					startActivityForResult(i,requestCode);
				}
			}
			
			break;
		case ItemOper.TYPE_AUDIO:			// audio
			i.setAction(Intent.ACTION_PICK);
			i.setData(MediaStore.Audio.Media.EXTERNAL_CONTENT_URI);
			startActivityForResult(i, requestCode);
			break;
		case ItemOper.TYPE_FILE:			// file
			i.setClass(ViewEntryBackup.this, ListFilePickr.class);
			startActivityForResult(i, requestCode);
			break;
		case ItemOper.TYPE_TASK:			// todo
			Task1 task = new Task1(this, mDbHelper);
			mCursorTask = task.fetchTaskHeaderAll(DBAdapter.PROJ_TASK_HEADER,Task1.HEADER_SORT_ORDER_KEY[mPrefTaskSortOrder]);
			removeDialog(DIA_TASK_PICKR);
			showDialog(DIA_TASK_PICKR);
			break;
		case ItemOper.TYPE_EXPN:			// expense
			Expense expn = new Expense(this, mDbHelper);
			mCursorExpn = expn.fetchExpenseHeaderAll(DBAdapter.PROJ_TASK_HEADER, Expense.HEADER_SORT_ORDER_KEY[mPrefExpnSortOrder]);
			removeDialog(DIA_EXPN_PICKR);
			showDialog(DIA_EXPN_PICKR);
			break;
		}
		
	}
	
	public void launchPickrPost(Uri uri, int requestCode) {
		if (MyApp.DEBUG) Log.e(TAG,"launchPickrPost");

		mID = new ItemData();
		
		File f = null;
		mID.type = requestCode;
		
		boolean contentFound = false;

		switch (requestCode) {
		case ItemOper.TYPE_PHOTO:
			// null uri is returned. don't know content provider id at this moment.
			if (mPrefPhotoFilePath!=null && mPrefPhotoFilePath.contains("OrangeDiary")) {
				// Good! FC File.fixSlashes()
			}
			else {		
				mPrefPhotoFilePath = mSharedPref.getString(SharePref.KEY_ATTACH_PHOTO_FILE_PATH, SharePref.VAL_ATTACH_PHOTO_FILE_PATH);
				mSharedPrefEdit.putString(SharePref.KEY_ATTACH_PHOTO_FILE_PATH, SharePref.VAL_ATTACH_PHOTO_FILE_PATH);
				mSharedPrefEdit.commit();
			}
			f = new File(mPrefPhotoFilePath);
			if (f.isFile()) {
				mID.title = "Photo "+DateFormat.format("yyMMdd_kkmmss", mPhotoTime).toString();
				mID.fileFullPath = mPrefPhotoFilePath;
				contentFound=true;
			}
			else {
				Toast.makeText(this, "Error 301\nPhoto file not found", Toast.LENGTH_LONG).show();
			}
			break;
		case ItemOper.TYPE_IMAGE:		
		case ItemOper.TYPE_VIDEO:		
		case ItemOper.TYPE_VOICE:		
		case ItemOper.TYPE_AUDIO:		
			String uriString = uri.toString();
			if (MyApp.DEBUG) Log.e(TAG, "uriString: "+uriString);
			
			if (uriString.contains("content:")) {
				String[] projection = { 
						MediaStore.MediaColumns.TITLE, 	// 0
						MediaStore.MediaColumns.DATA 	// 1
					};
				Cursor c = managedQuery(uri, projection, null, null, null);
				if (c!=null && c.moveToFirst()) {
					String data = c.getString(1);
					if (data!=null && data.length()>0) {
						mID.title = c.getString(0);
						mID.fileFullPath = data;
					}
					else {
						Toast.makeText(this, "Error 312\nReceived empty file name", Toast.LENGTH_LONG).show();
					}
				}
				else {
					Toast.makeText(this, "Error 313\nProblme in received content id", Toast.LENGTH_LONG).show();
				}
//				if (c!=null)	c.close();		// unlike local query, managedQuery can return null.
			}
			else if (uriString.contains("file:")){
				try {
					File f1 = new File(new URI(uriString));
					mID.title = ItemOper.ITEM_TYPE_DESC[requestCode];
					mID.fileFullPath = f1.getAbsolutePath();
				} 
				catch (Exception e) {
					Toast.makeText(this, "Error 315\nFailed to verify the the received file", Toast.LENGTH_LONG).show();
					e.printStackTrace();
				}
			}
			else {
				Toast.makeText(this, "Error 316\nUnknown uri prefix\n"+uriString, Toast.LENGTH_LONG).show();
			}

			f = new File(mID.fileFullPath);
			if (f.isFile()) {
				// image
				if (requestCode==ItemOper.TYPE_IMAGE || requestCode==ItemOper.TYPE_PHOTO ) {
					
					if (!f.getParent().contains(Multimedia.SEED_IMAGE)) {
						String local = Multimedia.makeLocal(f.getAbsolutePath(), ItemOper.TYPE_IMAGE, mED.id);
				    	if (local!=null) {
				    		mID.fileFullPath = local;
							contentFound = true;
				    	}
						else {
							contentFound = false;
							Toast.makeText(this, "Error 317\nFailed to copy the selected image to local folder", Toast.LENGTH_LONG).show();
						}
					}
					else {
						contentFound = true;
					}
				}
				// audio
				else if (requestCode==ItemOper.TYPE_VOICE || requestCode==ItemOper.TYPE_AUDIO) {	
					
					if (!f.getParent().contains(Multimedia.SEED_AUDIO)) {
						String local = Multimedia.makeLocal(f.getAbsolutePath(), ItemOper.TYPE_AUDIO, mED.id);
				    	if (local!=null) {
				    		mID.fileFullPath = local;
							contentFound = true;
				    	}
						else {
							contentFound = false;
							Toast.makeText(this, "Error 317\nFailed to copy the selected image to local folder", Toast.LENGTH_LONG).show();
						}
					}
					else {
						contentFound = true;
					}
				}
				// video
				else {										
					contentFound=true;
				}
			}
			else {
				Toast.makeText(this, "Error 314\nMultimedia file not found", Toast.LENGTH_LONG).show();
			}
			break;
		case ItemOper.TYPE_FILE:		
			f = new File(mGeneralFileFull);
			if (f.isFile()) {
				mID.title = getString(R.string.share_file);
				mID.fileFullPath = mGeneralFileFull;
				contentFound=true;
			}
			else {
				Toast.makeText(this, "Error 321\nSelected file not found", Toast.LENGTH_LONG).show();
			}
			break;
		case ItemOper.TYPE_TASK:		
			mID.title = getString(R.string.share_task);
			mID.fileFullPath = mGeneralFileFull;
			contentFound=true;
			break;
		case ItemOper.TYPE_EXPN:		
			mID.title = getString(R.string.share_expense);
			mID.fileFullPath = mGeneralFileFull;
			contentFound=true;
			break;
		}
		
		if (contentFound) {
			
			// Two steps
			// Step 1) - just create dummy entry
			// Step 2) - Update detail for barcode and web prod search
			//         - create item record for attached multimedia.
			
			// Step 1) - just create dummy entry
			if (mExtraEntryId==-1L) {
				String titleNew = MyApp.ITEM_TYPE_DESC[requestCode];
				switch (requestCode) {
				case ItemOper.TYPE_PHOTO:			titleNew = "Camera";			break;
				case ItemOper.TYPE_IMAGE:			titleNew = "Image";				break;
				case ItemOper.TYPE_VIDEO:			titleNew = "Video";				break;
				case ItemOper.TYPE_VOICE:			titleNew = "Voice";				break;
				case ItemOper.TYPE_AUDIO:			titleNew = "Audio";				break;
				case ItemOper.TYPE_FILE:			titleNew = "File";				break;
				case ItemOper.TYPE_TASK:			titleNew = "Task";				break;
				case ItemOper.TYPE_EXPN:			titleNew = "Expense";			break;
				}
				
				String body = "";
				long created = (mExtraCreated>0) ? mExtraCreated : System.currentTimeMillis();
				int groupid = (mExtraMarker>=0) ? mExtraMarker : mPrefMarkerDefault;
				long folderid = mExtraFolder;
				
				mExtraEntryId = mEntry1.createNote(titleNew, body, created, groupid, folderid);
				
				if (mExtraLabel!=null && mExtraLabel.length()>0) {
					String label = mExtraLabel;
					mDbHelper.createLabelI(mExtraEntryId, label);
				}
			}
			
			// Step 2)
			mID.entryid = mExtraEntryId;
			mID.id = mItem1.createItem(mID);
			
			// get focus position.
			if (mID.id>0) {
				if (mItemCursor!=null && ga_01!=null) {
					mItemCursor.requery();
					mSelectedItemPosition = mItemCursor.getCount()-1;
					if (requestCode==ItemOper.TYPE_TASK || requestCode==ItemOper.TYPE_EXPN) {	// task doesn't refresh scr
						refreshGa01Background();
						ga_01.setSelection(mSelectedItemPosition, true);
					}
				}
			}
		}
		else {
			String text =getString(R.string.noteedit_file_not_found)+"\n"+mID.fileFullPath;
			Toast.makeText(this, text, Toast.LENGTH_LONG).show();
		}
		
	}
	
	
	
    
	public void initFromIntent(Intent intent) {		// receiving note content through intent
		
        if(MyApp.DEBUG) Log.e(TAG,
    	        "Action: "+intent.getAction()+"\n"+
    	        "getDataString: "+intent.getDataString()+"\n"+
    	//        "getData: "+intent.getData().toString()+"\n"+
    	        "getScheme: "+intent.getScheme()+"\n"+
    	        "getType: "+intent.getType()+"\n"
            );
        
		DBAdapter dbHelper = new DBAdapter(this);
		EntryOper note1 = new EntryOper(this, dbHelper);
		ItemOper item1 = new ItemOper(this, dbHelper);
        SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(this);
        
        // Note
        String title = "";
        String body = "";
		long created = System.currentTimeMillis();
		int groupid = sp.getInt(SharePref.KEY_MARKER_DEFAULT_ID, MyPref.VAL_MARKER_DEFAULT_ID);
		long folderid = 0;
		
		// get EXTRA_SUBJECT
		if (intent.hasExtra(Intent.EXTRA_SUBJECT)) {
	        String extraString = intent.getStringExtra(Intent.EXTRA_SUBJECT);
	        if (extraString != null && extraString.length()>0) {
	        	title=extraString;
	        }
		}
        
        // get EXTRA_TEXT
		if (intent.hasExtra(Intent.EXTRA_TEXT)) {
	        CharSequence text = intent.getCharSequenceExtra(Intent.EXTRA_TEXT);
	        if (text != null && text.length()>0) {
	        	body += text;
	        }
		}
        
        dbHelper.open();
        long noteid = note1.createNote(title, body, created, groupid, folderid);
        if (noteid>0) {
            
        	// get EXTRA_STREAM 
            if (intent.hasExtra(Intent.EXTRA_STREAM)) {
            	
                String type = intent.getType();
                String mineType = type!=null ? type.substring(0, type.indexOf("/")) : "";
                Uri stream = (Uri) intent.getParcelableExtra(Intent.EXTRA_STREAM);
                String streamS = stream.toString();
                
                if (MyApp.DEBUG) Log.e(TAG, "Type: "+type+", Stream: "+stream);
                
                String title1 = "";
            	String fileFullPath = "";
            	int type1 = ItemOper.TYPE_IMAGE;
            	boolean contentFound = false;
            	
                // If the stream is content
                if (mineType.equals("image") && streamS.contains("content:")) {
                    
                	final String[] projection={
                		MediaStore.MediaColumns._ID,			// 0
                		MediaStore.MediaColumns.DATA,			// 1
                		MediaStore.MediaColumns.SIZE,			// 2
                		MediaStore.MediaColumns.MIME_TYPE,		// 3
                		MediaStore.MediaColumns.TITLE,			// 4
                		MediaStore.MediaColumns.DATE_ADDED,		// 5
                		MediaStore.MediaColumns.DISPLAY_NAME	// 6
                	};
                	
                	Cursor c = getContentResolver().query(stream, null, null, null, null);
                	
                	if (c!=null && c.moveToFirst()) {
                    	String[] xx = c.getColumnNames();
                    	
                		if (MyApp.DEBUG) for (int x=0; x<c.getColumnCount(); x++) Log.e(TAG, "Column "+x+": "+xx[x]);
                		
                		// Get title -- fill with TITLE or DISPLAY_NAME
            			if (!c.isNull(c.getColumnIndex(projection[4]))) {
            				title1 = c.getString(c.getColumnIndex(projection[4]));
            			}
            			else {
            				if (!c.isNull(c.getColumnIndex(projection[6]))) {
                				title1 = c.getString(c.getColumnIndex(projection[6]));
                			}
            			}
            			
            			// Get image
                		if (!c.isNull(c.getColumnIndex(projection[1]))) {
                			fileFullPath = c.getString(c.getColumnIndex(projection[1]));
     
                    		File f = new File(fileFullPath); 
                    		if (f.isFile()) {
                    			contentFound = true;
                    		}
                    		else {
                    			Toast.makeText(this, "Error 400.Cannot import image!\n"+fileFullPath, Toast.LENGTH_LONG).show();
                    		}
                		}
                	}
                	else {
                		Toast.makeText(this, "Error 401\nCannot import image!", Toast.LENGTH_LONG).show();
                	}
                	if (c!=null)	c.close();
                }
                // If the stream is file
            	else if (mineType.equals("image") && streamS.contains("file:")) {
            		File f;
					try {
						f = new File(new URI(streamS));
						if (f.isFile()) {
							fileFullPath = f.getAbsolutePath();
	            			contentFound = true;
	            		}
						else {
	            			Toast.makeText(this, "Error 403\nCannot import image!", Toast.LENGTH_LONG).show();
	            		}
					} catch (Exception e) {
						Toast.makeText(this, "Error 404\nCannot import image!", Toast.LENGTH_LONG).show();
					}
            	}
                
                if (contentFound) {
                	File f1 = new File(fileFullPath);
					if (!f1.getParent().contains(Multimedia.SEED_IMAGE)) {
						String local = Multimedia.makeLocal(f1.getAbsolutePath(), ItemOper.TYPE_IMAGE, noteid);
				    	if (local!=null) {
				    		if (title1.length() == 0) title1 = f1.getName();
							dbHelper.createItem(noteid, title1, local, ItemOper.TYPE_IMAGE);
				    	}
						else {
							contentFound = false;
							Toast.makeText(this, "Error 404\nFailed to bring image into local folder", Toast.LENGTH_LONG).show();
						}
					}
					else {
						if (title1.length() == 0) title1 = f1.getName();
						dbHelper.createItem(noteid, title1, fileFullPath, type1);
					}
                }
            }
        }
    	else {
    		String text1 = "Error 403\nCreation failed";
    		Toast.makeText(this, text1, Toast.LENGTH_LONG).show();
    		finish();
    	}
        dbHelper.close();

        mExtraEntryId = noteid;
    	mExtraItemType = 0;
    	mExtraCreated = 0L;
    	mExtraLabel = null;
    }

	synchronized public void generateThmBck() {
		if (MyApp.DEBUG) Log.e(TAG, "generateThmBck - start");
		
		Multimedia mm = new Multimedia(ViewEntryBackup.this);
		
		int missingThumbsCount = mMissingThumbList.size();
		for (int i=0; i<missingThumbsCount; i++) {
    		if (mforceCloseThread) {
    			if (MyApp.DEBUG) Log.e(TAG, "mforceCloseThread:"+mforceCloseThread);
    			break;
    		}
			String fileFullPath = mMissingThumbList.get(i);
			
			int x = mm.createThumb(fileFullPath, mExtraEntryId);
    		if (MyApp.DEBUG) Log.e(TAG, "Created missing Thumb:"+x+", "+fileFullPath);
    		System.gc();
			try {	Thread.sleep(200);	} catch (InterruptedException e) { }
		}
		
		if (MyApp.DEBUG) Log.e(TAG, "generateThmBck - end");

	}
	
	public void moveNotePosition(int direction) {
    	
		if (mExtraNoteIdArray==null || mExtraNoteIdArray.length==0) {
			return;
		}
		
		mSelectedItemPosition = -1;
		
    	if (direction==-1) {
    		mExtraNotePosition--;
			if (mExtraNotePosition<0) {
				mExtraNotePosition=0;
			}
			else {
				mExtraEntryId = mExtraNoteIdArray[mExtraNotePosition];
				
				preprocessing001();
				
				refreshNote();
		        refreshGa01();
//		    	refreshGa01Thumbnail();
		    	refreshPrevNextButton();
			}
    	}
    	else {
    		mExtraNotePosition++;
			if (mExtraNotePosition>=mExtraNoteIdArray.length) {
				mExtraNotePosition=mExtraNoteIdArray.length-1;
			}
			else {
				mExtraEntryId = mExtraNoteIdArray[mExtraNotePosition];
				
				preprocessing001();
				
				refreshNote();
		        refreshGa01();
//		    	refreshGa01Thumbnail();
		    	refreshPrevNextButton();
			}
    	}
    }

	
	// Layout
	private ImageView 		iv_add;
	private LinearLayout 	ll_rem_tag;
	private TextView 		tv_rem;
	private TextView 		tv_tag;
	private TextView 		tv_folder;
	private ImageView 		iv_star;
	private TextView 		tv_title;
	private ScrollView 	sv_01;
	private TextView 		tv_body01;
	private ImageView 		iv_mode;
	private LinearLayout	ln_01;
	private Gallery 		ga_01;
	private LinearLayout	ln_02;
	
	public void initContentView() {
		
		setTheme(R.style.MyLightTheme);
		setContentView(R.layout.view_note1);
		initActionBar();
		
        tv_folder = (TextView) findViewById(R.id.tv_folder);

        ll_rem_tag = (LinearLayout) findViewById(R.id.ll_rem_tag);
        tv_rem = (TextView) findViewById(R.id.tv_reminder);
        tv_tag = (TextView) findViewById(R.id.tv_tag);
        
        iv_star = (ImageView) findViewById(R.id.iv_star);
        tv_title = (TextView) findViewById(R.id.tv_title);
        sv_01 = (ScrollView) findViewById(R.id.sv_01);
        tv_body01 = (TextView) findViewById(R.id.tv_body01);
        iv_mode = (ImageView) findViewById(R.id.iv_mode);
        ga_01 = (Gallery) findViewById(R.id.ga_01);
        iv_add = (ImageView) findViewById(R.id.iv_add);
        
        tv_title.setTextSize(mPrefTextSizeT);
		tv_title.setTextColor(mPrefTextColor);
		tv_title.setTypeface(Theme100.getTypeface(this, mPrefTextType));
		
		ln_01 = (LinearLayout) findViewById(R.id.ln_01);
		ga_01.setAnimationDuration(2000);
		ln_02 = (LinearLayout) findViewById(R.id.ln_02);
//		tv_body01.setMovementMethod(new ScrollingMovementMethod()); 
		tv_body01.setTextSize(mPrefTextSizeB);
		tv_body01.setTextColor(mPrefTextColor);
		tv_body01.setTypeface(Theme100.getTypeface(this, mPrefTextType));

		((TextView) findViewById(R.id.tv_selectable)).setTextIsSelectable(true);
		tv_title.setTextIsSelectable(true);
		tv_body01.setTextIsSelectable(true);
		if (mPrefHyperlinkEnabled) {
			tv_body01.setAutoLinkMask(Linkify.ALL);
        }
		
		// mScaleGestureDetector = new ScaleGestureDetector(this, new MySimpleOnScaleGestureListener());
		
		setGestureDector();
		
        
	}
	
	private TextView 		tv_date;
	private TextView 		tv_time;
//	private ImageView 		iv_prev;
//	private ImageView 		iv_next;
	
	public void initActionBar() {
		
		LinearLayout ll_01 = (LinearLayout) findViewById(R.id.ll_01);
		RelativeLayout ll_date_emo = (RelativeLayout) findViewById(R.id.ll_date_emo);
        tv_date = (TextView) findViewById(R.id.tv_date);
        tv_time = (TextView) findViewById(R.id.tv_time);
//        iv_prev = (ImageView) findViewById(R.id.iv_prev);
//        iv_next = (ImageView) findViewById(R.id.iv_next);
        
        ll_01.setBackgroundColor(Theme100.COLOR_THEME[MyApp.PRF_THEME2][0]);
        ll_date_emo.setBackgroundResource(Theme100.BAR_RES[MyApp.PRF_THEME2]);
        tv_date.setTextColor(Theme100.COLOR_THEME[MyApp.PRF_THEME2][7]);
        tv_time.setTextColor(Theme100.COLOR_THEME[MyApp.PRF_THEME2][7]);
        
        tv_date.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				menuTriggered=false;
				showDialogDatePicker();
			}
        });
        
        tv_time.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				showDialogTimePicker();
			}
        });
        
//		iv_prev.setOnClickListener(new OnClickListener() {
//			public void onClick(View v) {
//				moveNotePosition(-1);
//			}
//        });
//		
//		iv_next.setOnClickListener(new OnClickListener() {
//			public void onClick(View v) {
//				moveNotePosition(1);
//			}
//        });
		
		
        
	}
	
	
	private void setGestureDector() {
		
		if (mExtraNoteIdArray==null || mExtraNoteIdArray.length==0) {
			return;
		}
		
		// Setup OnFling
		mGestureDetector = new GestureDetectorCompat(
				this, 
				new GestureDetector.OnGestureListener() {
			
					@Override
					public boolean onSingleTapUp(MotionEvent e) {
						// TODO Auto-generated method stub
						return false;
					}
					
					@Override
					public void onShowPress(MotionEvent e) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
//								Toast.makeText(ViewEntry.this, "onScroll: "+distanceX+", "+distanceY, Toast.LENGTH_SHORT).show();
						return false;
					}
					
					@Override
					public void onLongPress(MotionEvent e) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
//								Toast.makeText(ViewEntry.this, "onFling: "+velocityX+", "+velocityY, Toast.LENGTH_SHORT).show();
						if (Math.abs(velocityX)>Math.abs(velocityY)) {
							if (velocityX>0) {
								moveNotePosition(-1);
							}
							else {
								moveNotePosition(1);
							}
							return true;
						}
						else {
							return false;
						}
					}
					
					@Override
					public boolean onDown(MotionEvent e) {
						// TODO Auto-generated method stub
						return false;
					}
				});
		
		sv_01 = (ScrollView) findViewById(R.id.sv_01);
		sv_01.setOnTouchListener(
				new View.OnTouchListener() {
			
					@Override
					public boolean onTouch(View v, MotionEvent event) {
						if (mGestureDetector.onTouchEvent(event)) {
							return true;
						}
				        return false;
					}
				});

		
		tv_body01.setOnTouchListener(
				new View.OnTouchListener() {
			
					@Override
					public boolean onTouch(View v, MotionEvent event) {
//								if (mScaleGestureDetector.onTouchEvent(event)) {
//									return true;
//								}
						if (mGestureDetector.onTouchEvent(event)) {
							return false;
						}
				        return false;
					}
				});
		
	}
	
	
	public void showhideElem(int whichButton, boolean isChecked) {
    	mScreenElems[whichButton] = isChecked;
    	switch (whichButton) {
		case 0:		// attach
			if (isChecked) {
				iv_add.setVisibility(View.VISIBLE);
			}
			else {
				iv_add.setVisibility(View.GONE);
			}
			break;
		case 1:		// edit
			if (isChecked) {
				iv_mode.setVisibility(View.VISIBLE);
			}
			else {
				iv_mode.setVisibility(View.GONE);
			}
			break;
		}
    }
	 
    public void refreshNote() {

    	// get note detail
    	mED = mEntry1.getEntrySingle(mExtraEntryId);
    	if (mED.id<0) {
    		Toast.makeText(this, R.string.noteedit_no_requested_note, Toast.LENGTH_LONG).show();
    		finish();
    	}
    	
    	mTagData.refreshStatMulti(mED.tagIdList);
    	
//        String[] columns = DBAdapter.PROJ_ENTR;
//    	Cursor c = mDbHelper.fetchNote(columns, mExtraEntryId);
//    	if (c.moveToFirst()) {
//    		
//    		mED = new EntryData(c);
//    		mED.tagIdList = mEntry1.getTagList(mExtraEntryId);
//			mTagData.refreshStatMulti(mED.tagIdList);
//    	}
//    	else {
//    		Toast.makeText(this, R.string.noteedit_no_requested_note, Toast.LENGTH_LONG).show();
//    		finish();
//    	}
//		c.close();
    	
		refreshFolder();
        refreshDateTime();
        refreshRemTag();
        
        tv_title.setText(mED.title);
        tv_body01.setText(mED.note);
//        if (MyApp.DEBUG) tv_body01.setText("id:"+mExtraEntryId+" "+mBody);
        
        if (MyApp.PRF_MARKER_ENABLED) {
//			iv_star.setVisibility(View.VISIBLE);
	        iv_star.setImageResource(Icon.ICON_DRAWABLE_RES[mED.marker]);
		}
		else {
			iv_star.setImageResource(R.drawable.bullet_square_yellow);
//			iv_star.setVisibility(View.GONE);
		}
        
        

    }
    
    public void refreshGa01() {
    	if (MyApp.DEBUG) Log.e(TAG, "refreshGa01 - start");
    	
    	// Setup adapter for Gallery
        if (mItemCursor!=null) 	mItemCursor.close();
        
        String[] columns = ItemOper.PROJ_ALL;
    	mItemCursor = mDbHelper.fetchItemByNoteid(columns, mExtraEntryId);
    	int cursorCount = mItemCursor.getCount();
    	
    	CursorAdapterItem1 adapter = new CursorAdapterItem1(
				this,
				R.layout.view_note1_item_detail1,
				mItemCursor );
		
    	ga_01.setAdapter(adapter);
    	
    	// move the selected position
    	if (mSelectedItemPosition>=0 && mSelectedItemPosition<cursorCount) {
    		ga_01.setSelection(mSelectedItemPosition, true);
    	}
    	
    	refreshGa01Background();
    	
    }
    
    public void refreshGa01Background() {
    	
    	if (mItemCursor==null || mItemCursor.getCount()==0) {
    		ln_01.setVisibility(View.GONE);
			ln_02.setVisibility(View.GONE);
			ga_01.setVisibility(View.GONE);
    	}
    	else {
    		ln_01.setVisibility(View.VISIBLE);
			ln_02.setVisibility(View.VISIBLE);
			ga_01.setVisibility(View.VISIBLE);
    	}
    }
    
    public void refreshDateTime() {
		String date = "";
		String time = "";
        if (mDisplay.getWidth()<mDisplay.getHeight()) {			// Portrait
        	date = 
        		DateUtils1.getMMDDYYYYString(MyApp.DATE_FORMAT, mED.created)+"  "+
        		DateUtils1.getDayString(this, "EE", mED.created);
        	time = 
        		"  "+
        		DateUtils1.getTimeString(MyApp.TIME_FORMAT, mED.created,"h:mm");
        	tv_time.setTextAppearance(this, android.R.attr.textAppearanceSmall);
//        	tv_time.setTypeface(Typeface.DEFAULT_BOLD);
        }		
    	else {													// Landscape
    		date = 
    			DateUtils1.getMMMMDYYYYString(ViewEntryBackup.this, mED.created)+"    "+
    			DateUtils1.getDayString(this, "EEEEE", mED.created);
    		time = 
    			"    "+
        		DateUtils1.getTimeString(MyApp.TIME_FORMAT, mED.created,"h:mm");
    		tv_time.setTextAppearance(this, android.R.attr.textAppearanceLarge);
//        	tv_time.setTypeface(Typeface.DEFAULT_BOLD);
        }
        
        tv_date.setText(date);
        tv_time.setText(time);

	}
	
	public void refreshFolder() {
		
		if (mED.folderid==0) {
			tv_folder.setVisibility(View.GONE);
		}
		else {
			LabelOper2 folder = new LabelOper2(this, mDbHelper);
			String path = folder.getFullPath(mED.folderid);
			tv_folder.setVisibility(View.VISIBLE);
			tv_folder.setText(path);
		}
		
	}
	
	
	public void refreshRemTag() {
		
		boolean isReminderShown=false;
		boolean isTagShown=false;
		// Reminder
		if (mED.remindertime > System.currentTimeMillis()) {
        	String reminderTimeS = 
				DateUtils1.getMMDDString(MyApp.DATE_FORMAT, mED.remindertime)+" "+
				DateUtils1.getDayString(this, "EE", mED.remindertime)+", "+
				DateUtils1.getTimeString(MyApp.TIME_FORMAT, mED.remindertime,"h:mm");
        	tv_rem.setVisibility(View.VISIBLE);
        	tv_rem.setText(reminderTimeS);
        	
        	int remRes = (mED.remindertype==0) ? R.drawable.ic_tiny_notif_yellow : R.drawable.ic_tiny_alarm_yellow;
        	Drawable d = getResources().getDrawable(remRes);
        	tv_rem.setCompoundDrawablesWithIntrinsicBounds(d, null, null, null);
	        
        	isReminderShown=true;
		}
		else {
			tv_rem.setVisibility(View.GONE);
		}
		
		String tagString = mTagData.getLabelDesc();
		
		if (tagString!=null && tagString.length()>0) {
    		tv_tag.setVisibility(View.VISIBLE);
    		tv_tag.setText(tagString);
    		isTagShown=true;
    	}
    	else {
    		tv_tag.setVisibility(View.GONE);
    	}
		
		if (!isReminderShown && !isTagShown) {
			ll_rem_tag.setVisibility(View.GONE);
		}
		else {
			ll_rem_tag.setVisibility(View.VISIBLE);
		}
		
	}
	
	public void refreshPrevNextButton() {
//		if (mExtraNoteIdArray!=null && mExtraNoteIdArray.length>1) {
//			
//			if (mExtraNotePosition==0) {
//	    		iv_prev.setVisibility(View.INVISIBLE);
//	    	}
//	    	else {
//	    		iv_prev.setVisibility(View.VISIBLE);
//	    	}
//			
//			if (mExtraNotePosition==(mExtraNoteIdArray.length-1)) {
//	    		iv_next.setVisibility(View.INVISIBLE);
//	    	}
//	    	else {
//	    		iv_next.setVisibility(View.VISIBLE);
//	    	}
//		}
//		else {
//			iv_prev.setVisibility(View.INVISIBLE);
//			iv_next.setVisibility(View.INVISIBLE);
//		}
	}
    
	// preprocessing for path correction and thumbnail refresh
    public void preprocessing001() {
		if (MyApp.DEBUG) Log.e(TAG, "preprocessing001: start");
		
		mMissingThumbList = new ArrayList<String>();

		String[] columns = { DBAdapter.FLD_ITEM_FILEURI };
		long noteid = mExtraEntryId;
		String types = "0,1";
		Cursor c = mDbHelper.fetchItemByNoteidType(columns, noteid, types);
		int count = c.getCount();
		for (int i=0; i<count; i++) {
			c.moveToPosition(i);
			String fileuri = c.getString(0);
			fileuri = Multimedia.getFileAbsolutePath(ItemOper.TYPE_IMAGE, fileuri);
			if (MyApp.DEBUG) Log.e(TAG, "preprocessing001: fileuri:"+fileuri);
			
			File f1 = new File(fileuri);
			File f3 = new File(MyApp.THUMB_DIR,mExtraEntryId+"_"+f1.getName());
			
			if (f1.isFile() && f1.length()==0)		IOUtils.rm(f1);
			if (f3.isFile() && f3.length()==0)		IOUtils.rm(f3);
			
			if (f1.isFile() && !f3.isFile()) {	// original exist, thumb not-exist
				mMissingThumbList.add(fileuri);
				if (MyApp.DEBUG) Log.e(TAG, "preprocessing001: thumb:"+fileuri);
			}
		}
		c.close();
		
		if (MyApp.DEBUG) Log.e(TAG, "preprocessing001: missingCount:"+mMissingThumbList.size());
		
    	if (mMissingThumbList.size()>0) {
    		new Thread() {
    			@Override
    			public void run() {
    				generateThmBck();
    				handler.sendEmptyMessage(HANDLER_LOAD_THUMB);
    			}
    		}.start();
    	}
	}
    
	public void processTagNew(String title) {
		
		boolean insertResult = mLabel1.createLblM(title);
		if (insertResult) {
			mTagData = mLabel1.getAllLable();
			removeDialog(DIA_TAG_LST);				// TAG_INS called by TAG_LST. always return
			showDialog(DIA_TAG_LST);
		}
		else {
			Toast.makeText(this, R.string.share_creation_failed, Toast.LENGTH_SHORT).show();
		}
	
	}

	public void processFolderNew(String title) {
		
		int type = LabelOper2.TYPE_FLD;
		long parent = 0;
		long id = mLabel2.createLabel(type, title, parent);
		if (MyApp.DEBUG) Log.e(TAG, "processFolderNew: "+type+", "+parent+", "+id);
    	if (id>0) {
			removeDialog(DIA_FLD_LST);
			showDialog(DIA_FLD_LST);
    	}
		else {
    		Toast.makeText(this, R.string.share_creation_failed, Toast.LENGTH_SHORT).show();
		}
    	
	}
	
	
    
    
	
}