package com.acj0.orangediaryproa;


import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.acj0.orangediaryproa.data.DBAdapter;
import com.acj0.orangediaryproa.data.ItemOper;
import com.acj0.orangediaryproa.data.MyApp;
import com.acj0.share.R;
import com.acj0.share.utils.LogUtils;
import com.acj0.share.utils.Util;

public class PrefAdmintoolsBackup extends Activity {

	private static final String TAG="PrefThumbnail";
	
	// Menu
//	private static final int MENU_ITEM_SEND = 1;
	
	// MV
	private DBAdapter mDbHelper;
	private String mProcessMsg="";
	private int mCount;
	
	// Dialog
	private static final int DIA_00 = 			0;
	private static final int DIA_01 = 			1;
	private static final int DIA_02 = 			2;
	private static final int DIA_03 = 			3;
	private static final int DIA_04 = 			4;
	private static final int DIA_05 = 			5;
	private static final int DIA_06 = 			6;
	private static final int DIA_07 = 			7;
	private static final int DIA_08 = 			8;
	private static final int DIA_09 = 			9;
	
	// Preferneces
	private SharedPreferences mSharedPref;
	private SharedPreferences.Editor mSharedPrefEdit;

	// Handler
	private static final int HANDLER_MESSAGE = 						0;
	private static final int HANDLER_REMOVE_IMAGE_WITHOUT_ITEM = 	2;
	
	private ProgressDialog mProgressDialog;
	
	private final Handler handler = new Handler() {
		@Override
		public void handleMessage(final Message msg) {
			switch (msg.what) {
			case HANDLER_REMOVE_IMAGE_WITHOUT_ITEM:			// remove inconsistency
				mProgressDialog.dismiss();
				String text1 = mCount + " image files removed";
				
				Toast.makeText(PrefAdmintoolsBackup.this, text1, Toast.LENGTH_LONG).show();
				break;
			case HANDLER_MESSAGE:			// refresh
				mProgressDialog.setMessage(mProcessMsg);
				break;
			}
			
			
		}
	};
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		//setTitle("RosarySurf: Prayer Viewer");

		// Extras
        Bundle extras = getIntent().getExtras();
		if (extras != null) {
//			mSelectedFile = extras.getString("mSelectedFile");
		}

		// MV
		mDbHelper = new DBAdapter(this);
		
		mSharedPref = PreferenceManager.getDefaultSharedPreferences(this);
		mSharedPrefEdit = mSharedPref.edit();

		// Layout
		initContentView();
		
		bt_99[0].setOnClickListener(new OnClickListener() { public void onClick(View v) { showDialog(DIA_00); } });
//		bt_99[1].setOnClickListener(new OnClickListener() { public void onClick(View v) { showDialog(DIA_01); } });
//		bt_99[2].setOnClickListener(new OnClickListener() { public void onClick(View v) { showDialog(DIA_02); } });
//		bt_99[3].setOnClickListener(new OnClickListener() { public void onClick(View v) { showDialog(DIA_03); } });
//		bt_99[4].setOnClickListener(new OnClickListener() { public void onClick(View v) { showDialog(DIA_04); } });
		bt_99[9].setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				new LogUtils(MyApp.BASE_DIR).buildDialogForLog(PrefAdmintoolsBackup.this).show();
			}
		});
		

		
	}
	
	@Override
	protected void onResume() {
		super.onResume();
	}

	@Override
	protected void onPause() {
		super.onPause();
	}
	
	@Override
	protected void onDestroy() {
		super.onDestroy();
	}

	@Override 
    public void onSaveInstanceState(Bundle outState) {
    	super.onSaveInstanceState(outState); 
    }

    
    @Override
    public void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
    }
    
    @Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	
    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
//		menu.add(0, MENU_ITEM_SEND, 0, "Send to developer")
//		.setIcon(R.drawable.ic_menu_upload);
		return true;
	}

	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
		super.onPrepareOptionsMenu(menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
//	    switch (item.getItemId()) {
//	    case MENU_ITEM_SEND:
//			break;
//        }
		return true;
	}
	
	
	@Override
	protected Dialog onCreateDialog(int id) {
		//Log.e(TAG, "onCreateDialog");
    	switch (id) {
    	case DIA_00:				return buildDialog1300();
//		case DIA_01:				return buildDialog1301();
//		case DIA_02:				return buildDialog1302();
//		case DIA_03:				return buildDialog1303();
//		case DIA_04:				return buildDialog1304();
		}
		return null;
	}
    
    

	@Override
	protected void onPrepareDialog(int id, Dialog dialog) {
		
		CharSequence message = "";
//		
//		switch (id) {
//		case DIA_MENU:
//			dialog.setTitle(mSelectedLabel);
//			break;
//		}
	}
	
	
	// button 1
	public AlertDialog buildDialog1300() {
		
		String message = 
			"Do you really want to run this program?\n\n" +
			"This program will delete all the image files not being used by Orange Diary's entry.\n\n"+
			"Remark\n\n" +
			"1. Please make the copy of all files in /OrangeDiaryPro/photo folder. This program will remove the unused image files in the folder\n\n";
		
		AlertDialog.Builder dialogB = new AlertDialog.Builder(this)
		.setTitle("Remove unused image")
		.setMessage(message)
		.setPositiveButton(
				R.string.share_ok, 
				new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog, int whichButton) {
				    	RemoveOrphanItems();
				    }
				})
		.setNeutralButton(
				"Email dev.", 
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						Util.writeToDeveloper(PrefAdmintoolsBackup.this, null);
						
					}
				})
		.setNegativeButton(R.string.share_cancel, null);
		return dialogB.create();
	}
	
	
	// Layout
	private static final int[] BUTTON_RES = {
		R.id.bt_00, 	R.id.bt_01, 	R.id.bt_02, 	R.id.bt_03, 	R.id.bt_04, 	
		R.id.bt_05, 	R.id.bt_06, 	R.id.bt_07, 	R.id.bt_08, 	R.id.bt_09, 	
	};
	private static final int BUTTON_RES_COUNT = BUTTON_RES.length;
	
	private Button[] bt_99 = new Button[BUTTON_RES_COUNT];
	
	public void initContentView() {
		
		setContentView(R.layout.pref_admin_tools);
		
		ImageView iv_01 = (ImageView) findViewById(R.id.inc001_iv_01);
		TextView tv_01 = (TextView) findViewById(R.id.inc001_tv_01);
		
		for (int i=0; i<BUTTON_RES_COUNT; i++) {
			bt_99[i] = (Button) findViewById(BUTTON_RES[i]);
		}
		
		iv_01.setImageResource(R.drawable.ic_menud_settings);
		tv_01.setText(R.string.share_m_admintools_title);
		bt_99[0].setText("Remove unused image files");
		bt_99[1].setVisibility(View.GONE);
		bt_99[2].setVisibility(View.GONE);
		bt_99[3].setVisibility(View.GONE);
		bt_99[4].setVisibility(View.GONE);
		bt_99[5].setVisibility(View.GONE);
		bt_99[6].setVisibility(View.GONE);
		bt_99[7].setVisibility(View.GONE);
		bt_99[8].setVisibility(View.GONE);
		bt_99[9].setText("System logs");
		
	}
	
	
	// process ====================================
	
	public void RemoveOrphanItems() {
		
		String message = "Removing broken files ...";
		mProgressDialog = ProgressDialog.show(this, null, message, true, true);
		
		new Thread() {
			@Override
			public void run() {
				
				mDbHelper.open();
				
				ItemOper item = new ItemOper(PrefAdmintoolsBackup.this, mDbHelper);
				mCount = item.cleanupImageVoiceFolder();
				if (MyApp.DEBUG) Log.e(TAG, "Check 10; Result: "+mCount);
				
				mDbHelper.close();

				handler.sendEmptyMessage(HANDLER_REMOVE_IMAGE_WITHOUT_ITEM);
			}
		}.start();
	}
	
	
    public void setProgressMessage(String message) {
    	mProcessMsg = message;
    	handler.sendEmptyMessage(HANDLER_MESSAGE);
    }
	
	
	
	
	
}
